;Form (Dialog) Functions
;Written by Thomas A. Stevenson (wargamer)
;Blitzbasic 1.43



;Form and Alert Globals
Global Tot_obj=0, MaxDialogItems=50,max_obj=400,FormsMax=25,Formfocus
Dim obj(max_obj,9),objText$(max_obj),Form(FormsMax,MaxDialogItems),ReturnText$(max_obj)
Dim Atext$(30),Button$(3)
Dim DList$(1000),fil$(1000,2) 	;file selector 
Dim MessageTxt$(1)

;ColorSet globals
Const white=1,red=2,Green=3,Blue=4,gray=5,LtGray=6,yellow=7,majRiv=8
Const minRiv=9, black=10,Tcolor=11,Dcolor=12,MaskC=13,HexNumColor=14,HEXC=15,Rcolor=16
Global npatterns,MaxPatterN,background,backgroundfill=3
Dim pal(20,2),ct$(20)
ct$(0)="NA"
ct$(1)="White"
ct$(2)="Red"
ct$(3)="Green"
ct$(4)="Blue"
ct$(5)="Gray"
ct$(6)="LtGray"
ct$(7)="Yellow"
ct$(8)="MinRiv"
ct$(9)="MajRiv"
ct$(10)="Black"
ct$(11)="Tcolor"
ct$(12)="Dcolor"
ct$(13)="MaskC"
ct$(14)="HexNumcolor"
ct$(15)="HEXC"
ct$(16)="Rcolor"



Function Form_Event_Check(D,Dhand,img)

	;checks to see if any events have occured on Form D
	;does not update or draw form
	;returns object index or zero

	fx=obj(Form(D,1),1)
	fy=obj(Form(D,1),2)
	fw=obj(Form(D,1),3)
	fh=obj(Form(D,1),4)
		
	mx=MouseX()
	my=MouseY()
	If RectsOverlap(mx,my,1,1,fx,fy,fw,fh)
		sx=mx-fx
		sy=my-fy
		For n=1 To Form(D,0)
			objx=Form(D,n)
			If RectsOverlap(sx,sy,1,1,obj(objx,1),obj(objx,2),obj(objx,3),obj(objx,4)) Then
				Select 	obj(objx,0)
				Case 0
				Case 1 	;text (no background)
				Case 2 	;label
				Case 3 	;button
					While MouseDown(1)
						sx=mx-fx
						sy=my-fy
						If RectsOverlap(sx,sy,1,1,obj(objx,1),obj(objx,2),obj(objx,3),obj(objx,4)) Then
							obj(objx,8)=True
						Else
							obj(objx,8)=False
						EndIf
						DrawBlock img,0,0
						DrawBlock dHand,fx,fy
						Form_Update(D)
						mx=MouseX()
						my=MouseY()
						DrawImage mouseImage,mx,my
						Flip
					Wend
					FormFocus=objx
					If obj(objx,8)=True Then Return objx
				Case 4 	;Ckbox
					obj(objx,8)=Not obj(objx,8)
					While MouseDown(1):Wend
					FormFocus=objx
					Return objx
				Case 5	;radio
					For k=1 To Form(D,0)
						r=Form(D,k)
						If obj(r,0)=5 And obj(r,6)=obj(objx,6) Then obj(r,8)=False
					Next
					obj(objx,8)=True
					While MouseDown(1):Wend
					FormFocus=objx
					Return objx
				Case 6	;edit Text box
					Form_Edit_Text(D,objx)
					FormFocus=objx
					Return objx
				Case 7	;Hslider
					w=obj(objx,3)
					range=obj(objx,7)-obj(objx,6)
					While MouseDown(1)
						c=c+1
						HX=MouseX()-fx
						v=(HX-obj(objx,1)) * range/w+obj(objx,6)
						NewValue=MiniMax(v,obj(objx,6),obj(objx,7))
						If obj(objx,8)=NewValue Then
							FlushMouse
						Else
							obj(objx,8)=NewValue
							DrawBlock dHand,fx,fy
							Form_Update(D)
							DrawImage mouseImage,hx+fx,my
							Flip
						EndIf
					Wend
					FormFocus=objx
					Return objx
				Case 8	;Vslider
					h=obj(objx,4)
					range=obj(objx,7)-obj(objx,6)
					While MouseDown(1)
						Hy=MouseY()-fy
						v=(Hy-obj(objx,2)) * range/h+obj(objx,6)
						NewValue=MiniMax(v,obj(objx,6),obj(objx,7))
						If obj(objx,8)=NewValue Then
							FlushMouse
						Else
							obj(objx,8)=NewValue
							DrawBlock dHand,fx,fy
							Form_Update(D)
							FlushMouse 
							Flip
						EndIf
					Wend
					FormFocus=objx
					Return objx
				Case 9	;Title Bar drag
					dx=fx-mx
					dy=fy-my
					colorset(white)
					While MouseDown(1)
						mx=MouseX()
						my=MouseY()
						fx=MAX(mx+dx,0)
						fy=MAX(my+dy,0)
						DrawBlock img,0,0
						Rect fx,fy,fw,fh,0
						DrawImage mouseImage,mx,my
						Flip
					Wend
					obj(Form(D,1),1)=fx
					obj(Form(D,1),2)=fy
				Case 10	;List box
					If obj(objx,7)>0 Then SetFont(obj(objx,7))
					ItemH=FontHeight()
					cItem=(my-obj(objx,2)-fy)/itemH + obj(objx,5)
					If cItem<obj(objx,8)+1 Then obj(objx,6)=cItem
					FormFocus=objx
					Return objx
				Case 11	;Listbox slider
					MaxPos=obj(objx,2)+obj(objx,4)-obj(objx,7)
					While MouseDown(1)
						Hy=MouseY()-fy
						;new slider position
						obj(objx,5)=MINIMAX(hy,obj(objx,2),MaxPos)
						;new list position
						List=obj(objx,6)
						;1st list item to print =nItems * (Slider Position-offset)/Slider area
						obj(List,5)=obj(List,8)*(obj(objx,5)-obj(objx,2))/obj(objx,4)+1
						DrawBlock dHand,fx,fy
						Form_Update(D)
						Flip
					Wend
					FormFocus=objx
					Return objx
				Case 12	;dropdown selector
					If obj(objx,7)>0 Then SetFont(obj(objx,7))
					ItemH=FontHeight()
					dh=ItemH*obj(objx,5)+2
					cItem=obj(objx,8)
					y0=fy+obj(objx,2)+obj(objx,4)
					
					While MouseDown(1)
						DrawBlock img,0,0
						DrawBlock dHand,fx,fy
						Form_Update(D)
						mx=MouseX()
						my=MouseY()
						y=my-y0-2
						cItem=MINIMAX(Int(y/ItemH)+1,1,obj(objx,5))
						colorset(white)
						Rect fx+obj(objx,1),y0,obj(objx,3),dh
						colorset(black)
						Rect fx+obj(objx,1),y0,obj(objx,3),dh,0
						Viewport fx+obj(objx,1)+1,y0+1,obj(objx,3)-2,dh-2
						For k=1 To obj(objx,5)
							If k=cItem Then 
								colorset(RED)
								Rect fx+obj(objx,1)+2,y0+2+(k-1)*ItemH,obj(objx,3),ItemH
								colorset(black)
							EndIf
							s=1+obj(objx,6)*(k-1)	;start position to extract substring =Len()*(choice-1)
							t$=Mid$(objText$(objx),s,obj(objx,6))
							Text fx+obj(objx,1)+2,y0+2+(k-1)*ItemH,t$
						Next 
						Viewport 0,0,GraphicsWidth(),GraphicsHeight()
						DrawImage mouseImage,mx,my
						Flip
					Wend
					obj(objx,8)=cItem
					FormFocus=objx
					Return objx
				Case 13	;image
				Default
					Text 60,60,"object# "+Str$(objX)
				End Select
			EndIf
		Next
	Else
		;outside dialog box
		Return False
	EndIf

End Function


Function Form_Control(D,Dhand,img)

	fx=obj(Form(D,1),1)
	fy=obj(Form(D,1),2)
	fw=obj(Form(D,1),3)
	fh=obj(Form(D,1),4)
	Repeat
		DrawBlock img,0,0
		DrawBlock dHand,fx,fy
		keyObj=Form_Keys(D,Dhand,img)
		Form_Update(D)
		
		mx=MouseX()
		my=MouseY()
		If MouseDown(1)
			If RectsOverlap(mx,my,1,1,fx,fy,fw,fh)
				sx=mx-fx
				sy=my-fy
				For n=1 To Form(D,0)
					objx=Form(D,n)
					If RectsOverlap(sx,sy,1,1,obj(objx,1),obj(objx,2),obj(objx,3),obj(objx,4)) Then
						Select 	obj(objx,0)
						Case 0
						Case 1 	;text (no background)
						Case 2 	;label
						Case 3 	;button
							While MouseDown(1)
								sx=mx-fx
								sy=my-fy
								If RectsOverlap(sx,sy,1,1,obj(objx,1),obj(objx,2),obj(objx,3),obj(objx,4)) Then
									obj(objx,8)=True
								Else
									obj(objx,8)=False
								EndIf
								DrawBlock img,0,0
								DrawBlock dHand,fx,fy
								Form_Update(D)
								mx=MouseX()
								my=MouseY()
								DrawImage mouseImage,mx,my
								Flip
							Wend
							FormFocus=objx
							If obj(objx,8)=True Then Return objx
						Case 4 	;Ckbox
							obj(objx,8)=Not obj(objx,8)
							While MouseDown(1):Wend
							FormFocus=objx
							Return objx
						Case 5	;radio
							For k=1 To Form(D,0)
								r=Form(D,k)
								If obj(r,0)=5 And obj(r,6)=obj(objx,6) Then obj(r,8)=False
							Next
							obj(objx,8)=True
							While MouseDown(1):Wend
							FormFocus=objx
							Return objx
						Case 6	;edit Text box
							Form_Edit_Text(D,objx)
							FormFocus=objx
							Return objx
						Case 7	;Hslider
							w=obj(objx,3)
							range=obj(objx,7)-obj(objx,6)
							While MouseDown(1)
								c=c+1
								HX=MouseX()-fx
								v=(HX-obj(objx,1)) * range/w+obj(objx,6)
								NewValue=MiniMax(v,obj(objx,6),obj(objx,7))
								If obj(objx,8)=NewValue Then
									FlushMouse
								Else
									obj(objx,8)=NewValue
									DrawBlock dHand,fx,fy
									Form_Update(D)
									DrawImage mouseImage,hx+fx,my
									Flip
								EndIf
							Wend
							FormFocus=objx
							Return objx
						Case 8	;Vslider
							h=obj(objx,4)
							range=obj(objx,7)-obj(objx,6)
							While MouseDown(1)
								Hy=MouseY()-fy
								v=(Hy-obj(objx,2)) * range/h+obj(objx,6)
								NewValue=MiniMax(v,obj(objx,6),obj(objx,7))
								If obj(objx,8)=NewValue Then
									FlushMouse
								Else
									obj(objx,8)=NewValue
									DrawBlock dHand,fx,fy
									Form_Update(D)
									FlushMouse 
									Flip
								EndIf
							Wend
							FormFocus=objx
							Return objx
						Case 9	;Title Bar drag
							dx=fx-mx
							dy=fy-my
							colorset(white)
							While MouseDown(1)
								mx=MouseX()
								my=MouseY()
								fx=MAX(mx+dx,0)
								fy=MAX(my+dy,0)
								DrawBlock img,0,0
								Rect fx,fy,fw,fh,0
								DrawImage mouseImage,mx,my
								Flip
							Wend
							obj(Form(D,1),1)=fx
							obj(Form(D,1),2)=fy
						Case 10	;List box
							If obj(objx,7)>0 Then SetFont(obj(objx,7))
							ItemH=FontHeight()
							cItem=(my-obj(objx,2)-fy)/itemH + obj(objx,5)
							If cItem<obj(objx,8)+1 Then obj(objx,6)=cItem
							FormFocus=objx
							Return objx
						Case 11	;Listbox slider
							MaxPos=obj(objx,2)+obj(objx,4)-obj(objx,7)
							While MouseDown(1)
								Hy=MouseY()-fy
								;new slider position
								obj(objx,5)=MINIMAX(hy,obj(objx,2),MaxPos)
								;new list position
								List=obj(objx,6)
								;1st list item to print =nItems * (Slider Position-offset)/Slider area
								obj(List,5)=obj(List,8)*(obj(objx,5)-obj(objx,2))/obj(objx,4)+1
								DrawBlock dHand,fx,fy
								Form_Update(D)
								Flip
							Wend
							FormFocus=objx
							Return objx
						Case 12	;dropdown selector
							If obj(objx,7)>0 Then SetFont(obj(objx,7))
							ItemH=FontHeight()
							dh=ItemH*obj(objx,5)+2
							cItem=obj(objx,8)
							y0=fy+obj(objx,2)+obj(objx,4)
							
							While MouseDown(1)
								DrawBlock img,0,0
								DrawBlock dHand,fx,fy
								Form_Update(D)
								mx=MouseX()
								my=MouseY()
								y=my-y0-2
								cItem=MINIMAX(Int(y/ItemH)+1,1,obj(objx,5))
								colorset(white)
								Rect fx+obj(objx,1),y0,obj(objx,3),dh
								colorset(black)
								Rect fx+obj(objx,1),y0,obj(objx,3),dh,0
								Viewport fx+obj(objx,1)+1,y0+1,obj(objx,3)-2,dh-2
								For k=1 To obj(objx,5)
									If k=cItem Then 
										colorset(RED)
										Rect fx+obj(objx,1)+2,y0+2+(k-1)*ItemH,obj(objx,3),ItemH
										colorset(black)
									EndIf
									s=1+obj(objx,6)*(k-1)	;start position to extract substring =Len()*(choice-1)
									t$=Mid$(objText$(objx),s,obj(objx,6))
									Text fx+obj(objx,1)+2,y0+2+(k-1)*ItemH,t$
								Next 
								Viewport 0,0,GraphicsWidth(),GraphicsHeight()
								DrawImage mouseImage,mx,my
								Flip
							Wend
							obj(objx,8)=cItem
							FormFocus=objx
							Return objx
						Case 13	;image
						Default
							Text 60,60,"object# "+Str$(objX)
						End Select
					EndIf
				Next
			Else
				;outside dialog box
			EndIf
		EndIf
		
		DrawImage mouseImage,mx,my
		Flip
		If keyObj>0 Then Return keyObj
	Until KeyDown(1)

End Function


Function Obj_assign(d,typ,x,y,w,h,bord,insd,fnt,thck,txt$,ret$)

	If D>FormsMax Then Error_Msg("Obj_assign: Max Forms exceeded D="+Str$(D)): Return
	If Form(D,0)=MaxDialogItems Then Error_Msg("Obj_assign: Max Dialog items exceeded"): Return

  ;increament number of objects in obj()
	Tot_obj=Tot_obj+1
	;increament number of objects for Form(d,)
	Form(D,0)=Form(D,0)+1
	;store object index in Form(d,) 
	Form(d,Form(D,0))=Tot_obj
	
	If Tot_obj>max_obj Then 
		Error_Msg("Object Assign; tot_obj>max_obj "+ret$)
		tot_obj=200
	EndIf

	obj(Tot_obj,0)=typ
	obj(Tot_obj,1)=x
	obj(Tot_obj,2)=y
	obj(Tot_obj,3)=w
	obj(Tot_obj,4)=h
	obj(Tot_obj,5)=bord
	obj(Tot_obj,6)=insd
	obj(Tot_obj,7)=fnt
	obj(Tot_obj,8)=thck
	obj(Tot_obj,9)=D					;form id
	objText$(Tot_obj)=txt$
	ReturnText$(Tot_obj)=ret$
	
	Return Tot_obj
		
End Function


Function Form_RadioSet(FormID,ret$)
	;first find radio button to be pressed in
	For n=1 To Form(formID,0)
		i=Form(formID,n)
		If ret$=ReturnText$(i)
			pressed=i
			Exit
		EndIf
	Next

	If pressed=0 Then Return 0	;couldn't find button to press
	
	;set all radio buttons in group to not pressed
	For n=1 To Form(formID,0)
		i=Form(formID,n)
		;if radio button in same group as pressed?
		If obj(i,0)=5 And obj(i,6)=obj(pressed,6) Then obj(i,8)=False
	Next

	;pressed it and return
	obj(pressed,8)=True
	Return pressed

End Function


Function Form_Object(FN,ret$,fld,value)
	;returns object number based on value of return text field
	;also sets the objects value if fld>-1
	For n=1 To Form(fn,0)
		i=Form(fn,n)
		If ret$=ReturnText$(i)
			If fld>-1 Then obj(i,fld)=value
			Return i
		EndIf
	Next
	Error_Msg("Form Object; ret$ not found "+ret$)
End Function

;*************************************************************************

Function Form_Object_remove(FN,ObjectNumber)
	For n=1 To Form(fn,0)
		If ObjectNumber=Form(fn,n)
			;put last object in list in place of object being deleted
			Form(fn,n)=Form(fn,Form(fn,0))
			;decrease number of objects in form
			Form(fn,0)=Form(fn,0)-1
			Return
		EndIf
	Next
	Error_Msg("Form Object not found "+ObjectNumber)
End Function

;*************************************************************************


Function Form_Draw(D)
	;draws to current screen buffer
	;first object is the container for the rest
	;unlike imagedraw this function uses the index to Fonthand() ipo of Font handle directly

	mObj=Form(D,1)
	Origin obj(mObj,1),obj(mObj,2)
	
	xy=obj(mObj,8) ;border thickness or 3D
	If xy=-1		;3D Edge
		;inside color
		colorset(obj(mObj,6))
		Rect 0,0,obj(mObj,3),obj(mObj,4)
		w=obj(mObj,3): h=obj(mObj,4)
	 	ColorSet(White)
	 	Rect 0,0,w,h,0
		ColorSet(Black)
	  Line 1,h-1,w,h-1: Line w-1,1,w-1,h
	Else
		;border color
		colorset(obj(mObj,5))
		Rect 0,0,obj(mObj,3),obj(mObj,4)
		;inside color
		colorset(obj(mObj,6))
		Rect xy,xy,obj(mObj,3)-2*xy,obj(mObj,4)-2*xy
	EndIf

	;now draw remaining objects on form relative to container origin
	For n=1 To Form(D,0)
		i=Form(D,n)
		Select 	obj(i,0)
		Case 0	;Master container, already drawn
		Case 1 	;text (no background)
			SetFont FontHand(obj(i,7))
			colorset(obj(i,5))
			If obj(i,6)	;center text box
				Text obj(i,1)+obj(i,3) Shr 1,obj(i,2)+obj(i,4) Shr 1,objText$(i),True,True
			Else
				Text obj(i,1),obj(i,2),objText$(i)
			EndIf
		Case 2 ;label
			x=obj(i,1)
			SetFont(FontHand(obj(i,7)))
			colorset(obj(i,6))
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)
			colorset(obj(i,5))
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0
			If obj(i,8)	;center text in label
				Text obj(i,1)+obj(i,3) Shr 1,obj(i,2)+obj(i,4) Shr 1,objText$(i),True,True
			Else
				Text obj(i,1),obj(i,2),objText$(i),False,False
			EndIf
		Case 3 ;button
			FC=obj(i,5) 
			BC=obj(i,6) 
			ButtonBox(obj(i,1),obj(i,2),obj(i,3),obj(i,4),objText$(i),obj(i,7),FC,BC,False)
		Case 4 	;Ckbox
			Colorset(white)
			w=obj(i,3) + 1 -obj(i,3) Mod 2	; increse w by 1 if even
			h=w-1
			Rect obj(i,1),obj(i,2),w,h
			Colorset(black)
			Rect obj(i,1),obj(i,2),w,h,0
			SetFont(FontHand(obj(i,7)))
			If obj(i,5) Then cx=obj(i,5) Else cx=obj(i,1)+w+4
			If obj(i,6) Then cy=obj(i,6) Else cy=obj(i,2)
			Text cx,cy,objText$(i)
		Case 5	;radio
			Colorset(white)
			Oval obj(i,1),obj(i,2),obj(i,3),obj(i,3)
			Colorset(black)
			Oval obj(i,1),obj(i,2),obj(i,3),obj(i,3),0
			SetFont(FontHand(obj(i,7)))
			If obj(i,5) Then cx=obj(i,5) Else cx=obj(i,1)+obj(i,3)+2
			Text cx,obj(i,2),objText$(i)
		Case 6	;Edit Box
			SetFont(FontHand(obj(i,7)))
			colorset(obj(i,6))
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)
			colorset(obj(i,5))
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0
			Viewport obj(mObj,1)+obj(i,1)+1,	obj(mObj,2)+obj(i,2)+1,obj(i,3)-2,obj(i,4)-2
			Text obj(i,1)+2,obj(i,2)+1,	objText$(i)
			Viewport 0,0,scrnW,scrnH
		Case 7	;Hslider
			w=obj(i,3):h=obj(i,4)
			colorset(white)
  		Rect obj(i,1),obj(i,2),w,h
		  colorset(LtGray)
		  For y=0 To h
				x0= y Mod 2
		  	For x=x0 To w Step 2
			  	Plot obj(i,1)+x,obj(i,2)+y
				Next
		  Next
			w=obj(i,3):h=obj(i,4)
			range=obj(i,7)-obj(i,6)
			If range=0 Then Xpos=obj(i,1) Else Xpos=obj(i,1) + (obj(i,8)-obj(i,6))*w/range
			colorset(black)
			Rect Xpos-1,obj(i,2),3,h
			If obj(i,5)=-1 Then 
				v=Sgn(obj(i,8))*10^(Abs(obj(i,8)))
				If Sgn(obj(i,8))=0 Then v=1
				Text obj(i,1)+w+4,obj(i,2)+h/2,Str$(v),0,1
			ElseIf obj(i,5)=-2 Then 
				v=100*obj(i,8)
				Text obj(i,1)+w+4,obj(i,2)+h/2,Str$(v),0,1
			ElseIf obj(i,5) Then 
				Text obj(i,1)+w+4,obj(i,2)+h/2,Str$(obj(i,8)),0,1
			EndIf
		Case 8	;Vslider
			w= obj(i,3):h=obj(i,4)
			colorset(white)
  		Rect obj(i,1),obj(i,2),w,h
		  colorset(LtGray)
		  For y=0 To h
				x0= y Mod 2
		  	For x=x0 To w Step 2
			  	Plot obj(i,1)+x,obj(i,2)+y
				Next
		  Next
			w=obj(i,3):h=obj(i,4)
			colorset(white)
			range=obj(i,7)-obj(i,6)
			If range=0 Then Ypos=obj(i,2) Else Ypos=obj(i,2) + (obj(i,8)-obj(i,6))*h/range
			colorset(obj(mObj,5))	;use form default color
			Rect obj(i,1),Ypos-1,w,3
			If obj(i,5) Then Text obj(i,1)+w/2,obj(i,2)+h+4,Str$(obj(i,8)),1,0
		Case 9	;Title bar
			SetFont(FontHand(obj(i,7)))
			Select obj(i,8)
			Case 1
				tw=(obj(i,3)-StringWidth(objText$(i)))/2
				colorset(obj(i,6))
				For y=3 To obj(i,4) Step 2
					Line 2,y,tw,y
					Line obj(i,3)+2-tw,y,obj(i,3)-2,y
				Next
				Line 2,y,obj(mObj,3)-2,y
				colorset(obj(i,5))
				Text obj(i,3)/2,2,objText$(i),1
			Default
				For x=2 To obj(i,3)-2
					b=55+x*200/obj(i,3)
					rg=x*100/obj(i,3)
					Color rg,rg,b
					Line obj(i,1)+x,obj(i,2)+1,obj(i,1)+x,obj(i,2)+obj(i,4)-1
				Next
				Color 255,255,255
				Text obj(i,1)+2,obj(i,2)+2,objText$(i)
			End Select
		Case 10 ;list
			colorset(White)
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)		;fill
			colorset(black)
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0  ;border
		Case 11	;slider for list box
			Origin obj(i,1),obj(i,2)
			SliderBackground(obj(i,3),obj(i,4))
			Origin 0,0
			;Only vertical slider allowed
			SetFont(FontHand((obj(obj(i,6),7))))
			fh=FontHeight()
			;number of pixels per Item in list
			obj(i,8)=fh	
			;initial slider position
			obj(i,5)=obj(i,2)
			;total list size in terms of pixels
			Tpixs=fh*(obj(obj(i,6),8))
			;slider size =slider area * WinH/Total Window height
			VR=Int(obj(obj(i,6),4)/fh)*fh
			obj(i,7)=obj(i,4)*VR/Tpixs
			If 	obj(i,7)>obj(i,4) Then obj(i,7)=obj(i,4)
		Case 12	;drop down selector
			SetFont(FontHand(obj(i,7)))
			fh=FontHeight()
			colorset(white)
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)
			colorset(black)
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0
			Rect obj(i,1)+obj(i,3)-obj(i,4),obj(i,2),obj(i,4),obj(i,4),0
			w2=0
			For k=0 To obj(i,4)/3
				y=obj(i,2)+obj(i,4)-obj(i,4)/3-k
				x=obj(i,1)+obj(i,3)-obj(i,4)/2
				Plot x,y
				For j=0 To w2
					Plot x+j,y
					Plot x-j,y
				Next
				w2=w2+1
			Next
		Case 13	;image
			If obj(i,8)=0 Then DrawImage obj(i,5),obj(i,1),obj(i,2)
		Case 14	;image
			DrawImage obj(i,5),obj(i,1),obj(i,2)
		Default
		End Select
  Next

	;highlight active object
	Colorset(red)
	If obj(FF(cFF),0)=0 Then 
		Rect 0,0,obj(FF(cFF),3),obj(FF(cFF),4),0
		Rect obj(FF(cFF),3),(obj(FF(cFF),4) Shr 1) -6,4,12
		Rect (obj(FF(cFF),3) Shr 1) -6,obj(FF(cFF),4),12,4
	Else
		Rect obj(FF(cFF),1),obj(FF(cFF),2),obj(FF(cFF),3),obj(FF(cFF),4),0
		hy = obj(FF(cFF),2) + (obj(FF(cFF),4) Shr 1) -6
		Rect obj(FF(cFF),1)+obj(FF(cFF),3),hy,4,12
		hx = obj(FF(cFF),1) + (obj(FF(cFF),3) Shr 1) -6
		Rect hx,obj(FF(cFF),2)+obj(FF(cFF),4),12,4
	EndIf
	
	Origin 0,0	

End Function




Function Form_Image(D)

	;first object is the container for the rest
	mObj=Form(D,1)
	dHand=CreateImage(obj(mObj,3),obj(mObj,4))
	SetBuffer ImageBuffer(dHand)

	;draw box in border color first
	colorset(obj(mObj,5))
	Rect 0,0,obj(mObj,3),obj(mObj,4)
	xy=obj(mObj,8)
	 
	If xy=-1		;button like appearance
		x=0: y=0
		w=obj(mObj,3): h=obj(mObj,4)
	 	ColorSet(White)
	 	Rect x,y,w,h,0
		ColorSet(Black)
	  Line x+1,y+h-1,x+w,y+h-1: Line x+w-1,y+1,x+w-1,y+h
	Else
		;Inside color
		colorset(obj(mObj,6))
		Rect xy,xy,obj(mObj,3)-2*xy,obj(mObj,4)-2*xy
	EndIf

	;now draw remaining objects on form relative to container origin
	For n=1 To Form(D,0)
		i=Form(D,n)
		Select 	obj(i,0)
		Case 0	;Master container, already drawn
		Case 1 	;text (no background)
			If obj(i,7)>0 Then SetFont(obj(i,7))
			colorset(obj(i,5))
			Text obj(i,1),obj(i,2),objText$(i),obj(i,6)
		Case 2 ;label
			x=obj(i,1)
			If obj(i,7)>0 Then SetFont(obj(i,7))
			colorset(obj(i,6))
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)
			colorset(obj(i,5))
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0
			If obj(i,8)	;center text in label
				Text obj(i,1)+obj(i,3) Shr 1,obj(i,2)+obj(i,4) Shr 1,objText$(i),True,True
			Else
				Text obj(i,1),obj(i,2),objText$(i)
			EndIf
		Case 3 ;button
			FC=obj(i,5) 
			BC=obj(i,6) 
			ButtonBox(obj(i,1),obj(i,2),obj(i,3),obj(i,4),objText$(i),obj(i,7),FC,BC,False)
		Case 4 	;Ckbox
			Colorset(white)
			w=obj(i,3) + 1 -obj(i,3) Mod 2	; increse w by 1 if even
			h=w-1
			Rect obj(i,1),obj(i,2),w,h
			Colorset(black)
			Rect obj(i,1),obj(i,2),w,h,0
			If obj(i,7)>0 Then SetFont(obj(i,7))
			If obj(i,6) Then cy=obj(i,6) Else cy=obj(i,2)
			If obj(i,5) Then cx=obj(i,5) Else cx=obj(i,1)+w+4
			Text cx,cy,objText$(i)
		Case 5	;radio
			Colorset(white)
			Oval obj(i,1),obj(i,2),obj(i,3),obj(i,3)
			Colorset(black)
			Oval obj(i,1),obj(i,2),obj(i,3),obj(i,3),0
			If obj(i,7)>0 Then SetFont(obj(i,7))
			If obj(i,5) Then cx=obj(i,5) Else cx=obj(i,1)+obj(i,3)+2
			Text cx,obj(i,2),objText$(i)
		Case 6	;Edit Box
			colorset(obj(i,6))
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)
			colorset(obj(i,5))
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0
		Case 7	;Hslider
			w=obj(i,3):h=obj(i,4)
			colorset(white)
  		Rect obj(i,1),obj(i,2),w,h
		  colorset(LtGray)
		  For y=0 To h
				x0= y Mod 2
		  	For x=x0 To w Step 2
			  	Plot obj(i,1)+x,obj(i,2)+y
				Next
		  Next
		Case 8	;Vslider
			w= obj(i,3):h=obj(i,4)
			colorset(white)
  		Rect obj(i,1),obj(i,2),w,h
		  colorset(LtGray)
		  For y=0 To h
				x0= y Mod 2
		  	For x=x0 To w Step 2
			  	Plot obj(i,1)+x,obj(i,2)+y
				Next
		  Next
		Case 9	;Title bar
			If obj(i,7)>0 Then SetFont(obj(i,7))
			Select obj(i,8)
			Case 1
				tw=(obj(i,3)-StringWidth(objText$(i)))/2
				colorset(obj(i,6))
				For y=3 To obj(i,4) Step 2
					Line 2,y,tw,y
					Line obj(i,3)+2-tw,y,obj(i,3)-2,y
				Next
				Line 2,y,obj(mObj,3)-2,y
				colorset(obj(i,5))
				Text obj(i,3)/2,2,objText$(i),1
			Default
				For x=2 To obj(i,3)-2
					b=55+x*200/obj(i,3)
					rg=x*100/obj(i,3)
					Color rg,rg,b
					Line obj(i,1)+x,obj(i,2)+1,obj(i,1)+x,obj(i,2)+obj(i,4)-1
				Next
				Color 255,255,255
				Text obj(i,1)+2,obj(i,2)+2,objText$(i)
			End Select
		Case 10 ;list
			colorset(White)
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)		;fill
			colorset(black)
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0  ;border
		Case 11	;slider for list box
			Origin obj(i,1),obj(i,2)
			SliderBackground(obj(i,3),obj(i,4))
			Origin 0,0
			;Only vertical slider allowed
			If obj(obj(i,6),7)>0 Then SetFont(obj(obj(i,6),7))
			fh=FontHeight()
			;number of pixels per Item in list
			obj(i,8)=fh	
			;initial slider position
			obj(i,5)=obj(i,2)
			;total list size in terms of pixels
			Tpixs=fh*(obj(obj(i,6),8))
			;slider size =slider area * WinH/Total Window height
			VR=Int(obj(obj(i,6),4)/fh)*fh
			obj(i,7)=obj(i,4)*VR/Tpixs
			If 	obj(i,7)>obj(i,4) Then obj(i,7)=obj(i,4)
		Case 12	;drop down selector
			If obj(i,7)>0 Then SetFont(obj(i,7))
			fh=FontHeight()
			colorset(white)
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)
			colorset(black)
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0
			Rect obj(i,1)+obj(i,3)-obj(i,4),obj(i,2),obj(i,4),obj(i,4),0
			w2=0
			For k=0 To obj(i,4)/3
				y=obj(i,2)+obj(i,4)-obj(i,4)/3-k
				x=obj(i,1)+obj(i,3)-obj(i,4)/2
				Plot x,y
				For j=0 To w2
					Plot x+j,y
					Plot x-j,y
				Next
				w2=w2+1
			Next
		Case 13	;image
			If obj(i,8)=0 Then DrawImage obj(i,5),obj(i,1),obj(i,2)
		Case 14	;image
			DrawImage obj(i,5),obj(i,1),obj(i,2)
		Default
		End Select
  Next
	SetBuffer BackBuffer()
	
	Return dHand

End Function

;*************************************************************************
Function Form_Update(D)
	
	mObj=Form(D,1)					;index of master object
	Origin obj(mObj,1),obj(mObj,2)
	
	;indicate obj with focus
	If obj(FormFocus,9)=D
		Color 255,0,0
		Rect obj(FormFocus,1)-1,obj(FormFocus,2)-1,obj(FormFocus,3)+2,obj(FormFocus,4)+2,0
	EndIf
	
	;update objects
	For n=1 To Form(D,0)		;number of sub objects
		i=Form(D,n)						;index of Sub object
		Select 	obj(i,0)			;type of sub object
		Case -1 ;Updatable text (no background)
			If obj(i,7)>0 Then SetFont(obj(i,7))
			colorset(obj(i,5))
			Text obj(i,1),obj(i,2),objText$(i),obj(i,6)
		Case 1 	;text (no background)
		Case 2 	;label
		Case 3 	;button
			If obj(i,8)=True Then
				FC=obj(i,5) 
				BC=obj(i,6) 
				ButtonBox(obj(i,1),obj(i,2),obj(i,3),obj(i,4),objText$(i),obj(i,7),FC,BC,True)
			EndIf
		Case 4 	;Ckbox
			If obj(i,8) Then
				w=obj(i,3) + 1 -obj(i,3) Mod 2	; increse w by 1 if even
				h=w-1
 				x0=obj(i,1)+2:	x2=obj(i,1)+w-4
				y0=obj(i,2)+2:	y2=obj(i,2)+h-3
				Colorset(black)
				Line x0  ,y0,  x2+1,y2+1
				Line x0+1,y0,x2+1+1,y2+1
				Line x0  ,y2,x2  ,y0
				Line x0+1,y2,x2+1,y0
			EndIf
		Case 5	;radio
			Colorset(black)
			If obj(i,8) Then Oval obj(i,1)+2,obj(i,2)+2,obj(i,3)-4,obj(i,3)-4
		Case 6	;Edit text box
			If obj(i,7)>0 Then SetFont(obj(i,7))
			colorset(obj(i,6))
			Rect obj(i,1)+1,obj(i,2)+1,obj(i,3)-2,obj(i,4)-2
			colorset(obj(i,5))
			Viewport obj(mObj,1)+obj(i,1)+1,	obj(mObj,2)+obj(i,2)+1,obj(i,3)-2,obj(i,4)-2
			Text obj(i,1)+2,obj(i,2)+1,	objText$(i)
			Viewport 0,0,scrnW,scrnH
		Case 7	;Hslider
			w=obj(i,3):h=obj(i,4)
			range=obj(i,7)-obj(i,6)
			If range=0 Then Xpos=obj(i,1) Else Xpos=obj(i,1) + (obj(i,8)-obj(i,6))*w/range
			colorset(black)
			Rect Xpos-1,obj(i,2),3,h
			SetFont(FontHand(0))
			If obj(i,5)=-1 Then 
				v=Sgn(obj(i,8))*10^(Abs(obj(i,8)))
				If Sgn(obj(i,8))=0 Then v=1
				Text obj(i,1)+w+4,obj(i,2)+h/2,Str$(v),0,1
			ElseIf obj(i,5)=-2 Then 
				v=100*obj(i,8)
				Text obj(i,1)+w+4,obj(i,2)+h/2,Str$(v),0,1
			ElseIf obj(i,5) Then 
				Text obj(i,1)+w+4,obj(i,2)+h/2,Str$(obj(i,8)),0,1
			EndIf
		Case 8	;Vslider
			w=obj(i,3):h=obj(i,4)
			colorset(white)
			range=obj(i,7)-obj(i,6)
			If range=0 Then Ypos=obj(i,2) Else Ypos=obj(i,2) + (obj(i,8)-obj(i,6))*h/range
			colorset(obj(mObj,5))	;use form default color
			Rect obj(i,1),Ypos-1,w,3
			SetFont(FontHand(0))
			If obj(i,5) Then Text obj(i,1)+w/2,obj(i,2)+h+4,Str$(obj(i,8)),1,0
		Case 10 ;list
			If obj(i,7)>0 Then SetFont(obj(i,7))
			fh=FontHeight()
			Origin obj(mObj,1),obj(mObj,2)
			colorset(White)
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4)		;fill
			colorset(black)
			Rect obj(i,1),obj(i,2),obj(i,3),obj(i,4),0  ;border
			Viewport obj(mObj,1)+obj(i,1)+1,obj(mObj,2)+obj(i,2)+1,obj(i,3)-2,obj(i,4)-2
			
			VisibleLines=obj(i,3)/fh 
			For k=0 To visibleLines
				y=obj(i,2)+2+K*fh
				item=k+obj(i,5)					;k+1st item visible on list
				If item = obj(i,6) Then ;currenly selected item
				  colorset(red)
				  Rect obj(i,1),y-1, obj(i,3),fh+2
					colorset(black)
					Text obj(i,1)+2,y,Dlist$(item)
				ElseIf item>obj(i,8)
				Else
					Text obj(i,1)+2,y,Dlist$(item)
				EndIf
			Next 
			Viewport 0,0,GraphicsWidth(),GraphicsHeight()
		Case 11		;slider for list
			colorset(gray)
			Rect obj(i,1),obj(i,5),obj(i,3),obj(i,7)
		Case 12		;drop down selector
			If obj(i,7)>0 Then SetFont(obj(i,7))
			fh=FontHeight()
			Viewport obj(mObj,1)+obj(i,1)+1,obj(mObj,2)+obj(i,2)+1,obj(i,3)-2,obj(i,4)-2
			colorset(white)
			Rect obj(i,1),obj(i,2),obj(i,3)-obj(i,4),obj(i,4)
			colorset(black)
			s=1+obj(i,6)*(obj(i,8)-1)	;start position to extract substring =Len()*(choice-1)
			If s<1 Then s=1
			t$=Mid$(objText$(i),s,obj(i,6))
			Text obj(i,1)+2,obj(i,2)+1,t$
			Viewport 0,0,GraphicsWidth(),GraphicsHeight()
		Case 13	;Animated image
			;obj(i,8)==current frame (high word), nFrames (low word)
			If MilliSecs()-obj(i,6)>obj(i,7) Then
				frame=obj(i,8) Shr 16 + 1
				frame=frame Mod (obj(i,8) And LowB) 
				obj(i,6)=MilliSecs()
				obj(i,8)=(obj(i,8) And LowB) + frame Shl 16
			EndIf
			frame=obj(i,8) Shr 16 
			DrawImage obj(i,5),obj(i,1),obj(i,2),frame
			Default
		End Select
  Next
	Origin 0,0

End Function


;*************************************************************************

Function Form_Edit_Text(D,objx)
	msecs=85	;repeat delay
	mask$="any"
	If obj(objx,7)>0 Then SetFont(obj(objx,7))
	
	fw=FontWidth()+2
	h=FontHeight()+2
	r$=objText$(objx)
	
	pos=Len(r$)  ;location of cursor relative to text
	xpos=pos	 ;old cursor position

	;draw border and set clipping so everthing stays inside border
	mObj=Form(D,1)
	x=obj(mObj,1)+obj(objx,1)
	y=obj(mObj,2)+obj(objx,2)
	w=obj(objx,3)
	h=obj(objx,4)
	colorset(obj(objx,5)) 
	Origin x,y
	Rect 0,0,w,h,0		;border
	Viewport x+1,y+1,w-2,h-2

	Repeat
	  ;calc cursor and text positions
	  x0=StringWidth(Left$(r$,pos))
	  cpos=x0  ;location of cursor relative to screen
	  If cpos>w-Fw Then cpos=w-Fw

		;fill background	
		;colorset(obj(objx,6))
		colorset(red)
	  Rect 0,0,w-2,h-2
	  ;draw text  
		;colorset(obj(objx,5))
		colorset(white)
	  Text cpos-x0,1,r$
	  Line cpos+1,2,cpos+1,h-2
		Flip

    ;get keyboard input
	  Repeat
			action=False
			;check for end of editing
			If KeyDown(1) Then r$=objText$(objx):done=True 	;esc
			If KeyDown(156) Then done=True									;enter
			If KeyDown(28)  Then done=True									;enter
			;check deletions
			If KeyDown(14) Then      												;backspace
			  If pos>0 Then 
				 	r$=Left$(r$,pos-1)+Right$(r$,Len(r$)-pos)
					pos=pos-1
			  EndIf
				Delay msecs
			EndIf
			If KeyDown(211) Then      											;Delete
			  If pos<Len(r$) Then 
				 	r$=Left$(r$,pos)+Right$(r$,Len(r$)-pos-1)
					Action=True	 ;needed because position hasn't changed
			  EndIf
				Delay msecs
			EndIf
			
			;check keypad /ignores number lock
			keypad$=""
			If KeyDown(82) Then keypad$="0"
			If KeyDown(79) Then keypad$="1"
			If KeyDown(80) Then keypad$="2"
			If KeyDown(81) Then keypad$="3"
			If KeyDown(75) Then keypad$="4"
			If KeyDown(76) Then keypad$="5"
			If KeyDown(77) Then keypad$="6"
			If KeyDown(71) Then keypad$="7"
			If KeyDown(72) Then keypad$="8"
			If KeyDown(73) Then keypad$="9"
			If Len(keypad$) Then action=True: Delay msecs
			
			;check for cursor movement
			If KeyDown(203) Then 							;left arrow
			  If pos>0 Then pos=pos-1 
				Delay msecs
			EndIf   
			If KeyDown(205) Then							;right arrow
			  If pos<Len(r$) Then pos=pos+1
				Delay msecs
			EndIf
			If KeyDown(199) Then pos=0 				;home
			If KeyDown(207) Then pos=Len(r$)	;end
			If pos<>xPos Then
			  action=True
			  xpos=pos
			EndIf
			
		  keyASC=GetKey()
	  	If (KeyASC>31 And KeyASC<127) Then c$=Chr$(KeyASC) Else c$=Keypad$
	
	  	If Len(c$) Then
	     	If mask$="any" Or Instr(mask$,c$) Then
				  If pos=Len(r$) Then 
				  	r$=r$+c$
				  ElseIf pos=0 Then
				  	r$=c$+r$
				  Else
				  	r$=Left$(r$,pos)+c$+Right$(r$,Len(r$)-pos)
				  EndIf
			  	pos=pos+1
		  	EndIf
				action= True
				;keyUp()
				While GetKey():Wend
	   	EndIf
	  Until action Or done
		;redraw textbox
	Until done
	
	Viewport 0,0,GraphicsWidth(),GraphicsHeight()
	Origin 0,0
	objText$(objx)=r$
	
End Function


Function Form_Test(s)

	TF=Form_Image(s)
	BF=CreateImage(scrnW,ScrnH)
	Formfocus=Focus_Find(s)
	Repeat
		ObjIndex=form_control(s,TF,BF)
	Until KeyDown(1)
	FreeImage BF
	FreeImage TF
	
End Function


Function Focus_Next(D)

	If KeyDown(shift2) Or KeyDown(shift1) Then s=-1 Else s=1
	For n=1 To Form(D,0)		;number of sub objects
		If FormFocus=Form(D,n) Then Exit
	Next
	
	Repeat
		If s=1 Then
			n=n+1
			If n>Form(D,0) Then n=1: L=L+1
		Else
			n=n-1
			If n<1 Then n=Form(D,0): L=L+1
		EndIf
		If L=2 Then Return 0
				
		i=Form(D,n)						;index of Sub object
		Select 	obj(i,0)			;type of sub object
		Case -1 ;Updatable text (no background)
		Case 1 	;text (no background)
		Case 2 	;label
		Case 3 	;button
			Return i
		Case 4 	;Ckbox
			Return i
		Case 5	;radio
			Return i
		Case 6	;Edit text box
			Return i
		Case 7	;Hslider
			Return i
		Case 8	;Vslider
			Return i
		Case 10 ;list
			Return i
		Case 11		;slider for list
		Case 12		;drop down selector
			Return i
		Case 13	;Animated image
		Default
		End Select
  Forever
	Return 0
		
End Function


Function	Form_center(D)
	mObj=Form(D,1)
	obj(mObj,1)=(scrnW-obj(mObj,3)) Shr 1
	obj(mObj,2)=(scrnH-obj(mObj,4)) Shr 1
End Function


Function Focus_Find(D)

	For n=1 To Form(D,0)		;number of sub objects
		i=Form(D,n)						;index of Sub object
		Select 	obj(i,0)			;type of sub object
		Case -1 ;Updatable text (no background)
		Case 1 	;text (no background)
		Case 2 	;label
		Case 3 	;button
			Return i
		Case 4 	;Ckbox
			Return i
		Case 5	;radio
			Return i
		Case 6	;Edit text box
			Return i
		Case 7	;Hslider
			Return i
		Case 8	;Vslider
			Return i
		Case 10 ;list
			Return i
		Case 11		;slider for list
		Case 12		;drop down selector
			Return i
		Case 13	;Animated image
		Default
		End Select
  Next
	Return 0
		
End Function
;*************************************************************************


Function Form_Keys(D,dHand,img)

	If obj(FormFocus,9)<>D Then Focus_Find(D)
	If KeyDown(15) Then 
		FormFocus=Focus_Next(D): While KeyDown(15): Wend
		Return 0
	EndIf
	
	Select obj(FormFocus,0)
	Case -1 ;Updatable text (no background)
	Case 1 	;text (no background)
	Case 2 	;label
	Case 3 	;button
		If KeyDown(28)
			obj(FormFocus,8)=Not obj(FormFocus,8)
			DrawBlock img,0,0
			DrawBlock dHand,obj(Form(D,1),1),obj(Form(D,1),2)
			Form_Update(D)
			Flip
			While KeyDown(28) :Wend
			Return FormFocus
		EndIf
	Case 4 	;Ckbox
		If KeyDown(28) Or KeyDown(57) Then 
			obj(FormFocus,8)=Not obj(FormFocus,8)
			While KeyDown(28) Or KeyDown(57): Wend
			FormFocus=Focus_Next(D)
			Return FormFocus
		EndIf
	Case 5	;radio
		If KeyDown(28) Or KeyDown(57) Then 
			For k=1 To Form(D,0)
				r=Form(D,k)
				If (obj(r,0)=5) And (obj(r,6)=obj(FormFocus,6)) Then obj(r,8)=False
			Next
			obj(FormFocus,8)=True
			While KeyDown(28) Or KeyDown(57): Wend
			Return FormFocus
		EndIf
	Case 6	;Edit text box
		Return i
	Case 7	;Hslider
		If KeyDown(203) Or KeyDown(74) Or KeyDown(12) ;left or minus
			obj(FormFocus,8)=MiniMax(obj(FormFocus,8)-1,obj(FormFocus,6),obj(FormFocus,7))
			t0=MilliSecs()
			While KeyDown(203) Or KeyDown(74) Or KeyDown(12)
				If MilliSecs()-t0>25 Then Exit
			Wend
			Return FormFocus
		EndIf
		If KeyDown(205) Or KeyDown(78) Or KeyDown(13) ;right or equal or plus
			obj(FormFocus,8)=MiniMax(obj(FormFocus,8)+1,obj(FormFocus,6),obj(FormFocus,7))
			t0=MilliSecs()
			While KeyDown(205) Or KeyDown(78) Or KeyDown(13)
				If MilliSecs()-t0>25 Then Exit
			Wend
			Return FormFocus
		EndIf
		If KeyDown(199) ;home 
			obj(FormFocus,8)=obj(FormFocus,6)
			While KeyDown(199): Wend
			Return FormFocus
		EndIf
		If KeyDown(207) ;end
			obj(FormFocus,8)=obj(FormFocus,7)
			While KeyDown(207): Wend
			Return FormFocus
		EndIf
	Case 8	;Vslider
		If KeyDown(208) Or KeyDown(74) Or KeyDown(12) ;down or minus
			obj(FormFocus,8)=MiniMax(obj(FormFocus,8)-1,obj(FormFocus,6),obj(FormFocus,7))
			t0=MilliSecs()
			While KeyDown(208) Or KeyDown(74) Or KeyDown(12)
				If MilliSecs()-t0>25 Then Exit
			Wend
			Return FormFocus
		EndIf
		If KeyDown(200) Or KeyDown(78) Or KeyDown(13) ;up or equal or plus
			obj(FormFocus,8)=MiniMax(obj(FormFocus,8)+1,obj(FormFocus,6),obj(FormFocus,7))
			t0=MilliSecs()
			While KeyDown(200) Or KeyDown(78) Or KeyDown(13)
				If MilliSecs()-t0>25 Then Exit
			Wend
			Return FormFocus
		EndIf
		If KeyDown(199) ;home 
			obj(FormFocus,8)=obj(FormFocus,6)
			While KeyDown(199): Wend
			Return FormFocus
		EndIf
		If KeyDown(207) ;end
			obj(FormFocus,8)=obj(FormFocus,7)
			While KeyDown(207): Wend
			Return FormFocus
		EndIf
	Case 10 ;list
		Return i
	Case 11		;slider for list
	Case 12		;drop down selector
		Return i
	Case 13	;Animated image
	Default
	End Select
	
End Function


Function keyUp()
	Repeat
		AllUp=True
		For i=1 To 237
		;For i=32 To 126
			If KeyDown(i) Then AllUP=False
		Next
		If AllUp Then Return
	Forever
	FlushKeys()
End Function


;****************************************************


	
Function ALERT (nText,nButtons,img)
  ;Require Globals: aText$(),buttons$(),mouseImage 
  ;Img is the handle for the current screen image
  ;this routine sets the buffer to the backbuffer
  ;Set the font and backbuffer() before calling

  ;the esc key selects the last button
  ;enter selects the first button

 	;calc width and Height of Alert box
	If NewRoman>0 Then SetFont NewRoman
	;1st find longest button
	buttonW=StringWidth(Button$(1))
	For i=2 To nbuttons
		w=StringWidth(Button$(i))
		If w>buttonW Then buttonW=w
	Next 
	;Now find longest Line including button line
	w=(buttonW+20)*nButtons = 20  
	For i = 1 To nText
    	wd = StringWidth(AText$(I)) + 40
		If wd>w Then w=wd
  	Next 
	;Calculate Height
  	FontH=FontHeight()+4
  	h=(nText+1)*(FontH)+10
	;Calculate box cordinates To center Alert on screen
	bx = (GraphicsWidth() - w) / 2
	by = (GraphicsHeight() - H) / 2
	
    ;create images for the screen and Alert Box
	Abox=CreateImage(w,h)
		 
	;draw box 
	Origin bx,by
  	Color 255,0,0
  	Rect 0, 0, w , H
  	Color 130,130,130
  	Rect 2,2, w-4, H-4
  	Color 0,0,0
 		;draw text, center text if first character is not a space
  	For i = 1 To nText
			If Left$(AText$(i),1)=" " Then
    		Text  20,  10+(i-1) * FontH  , AText$(i)
			Else
		   	Text  w/2,  10+(i-1) * FontH  , AText$(i),1,0
		  EndIf
  	Next
	;draw buttons
	wb=w/nButtons
	y=nText * FontH + 4
	For i=1 To nButtons
		Color 255,0,0
		x=wb*(i-1)
		Rect x+(wb-buttonW)/2,y,buttonW+4,FontH
		Color 0,0,0
		Rect x+(wb-buttonW)/2,y,buttonW+4,FontH,0
		Text x+wb/2+2,y+2,button$(i),1,0
	Next

	Origin 0,0
	GrabImage Abox,bx,by
	MoveMouse bx+w/2,by+h-4
	DrawImage mouseImage,bx,by
	Flip

	While MouseDown(1):Wend ;wait for mouse release before proceeding
	While KeyDown( 1): Wend
	While KeyDown(28): Wend

	Repeat
		mx=MouseX()
		my=MouseY()
		If KeyDown(1) Then Pick=nButtons	: While KeyDown( 1): Wend
		If KeyDown(28) Then pick=1				: While KeyDown(28): Wend
		If MouseDown(1)
			;check to see whick button was pressed
			sx=mx-bx
			sy=my-by
			If sy>y And sy-y<FontH+4 Then
			  ;the pointer is on the button Line
			  For i=1 To nButtons
				x=wb*(i-1)+wb/2
				If Abs(sx-x)<wb/2 Then Pick=i
			  Next
			ElseIf RectsOverlap(sx,sy,1,1,0,0,w,h) Then
			  ;the mouse is down inside the box, repostion box
			  Repeat
				gx=MouseX()
				gy=MouseY()
				DrawBlock img,0,0
				DrawBlock Abox,bx+(gx-mx),by+(gy-my)
				DrawImage MouseImage,gx,gy
				Flip
			  Until Not MouseDown(1)
			  bx=bx+(gx-mx)
			  by=by+(gy-my)
			EndIf
		EndIf
		DrawBlock img,0,0
		DrawBlock Abox,bx,by
		Color 255,0,0
		DrawImage mouseImage,mx,my
		Flip
	Until Pick
	
	DrawBlock img,0,0	;restore the screen
	FreeImage aBox
	Flip
	While MouseDown(1):Wend			;wait for mouse release before returning
	Return pick

End Function


Function Message (msg$, msecs,img)
  ;The calling routine needs to pass a image of the screen w/o the mouse
	;assumes backbuffer() is active 
	;and MouseImage has been created

	SetFont MsgFont
  FontH=FontHeight()
  FontW=FontWidth()

  bx = 300: by = 200
  ;Determine number of lines in message
  For i = 1 To Len(msg$)
    If Mid$(msg$, i, 1) = "|" Then k = k + 1
  Next 

  ;seperate message into seperate lines
  Dim MessageTxt$(k + 1)
  For i = 1 To k
    P = Instr(msg$, "|")
    MessageTxt$(i) = Left$(msg$, P - 1)  
    msg$ = Right$(msg$, Len(msg$) - P)
  Next 
  MessageTxt$(k + 1) = msg$
  
  ;find longest Line
  ww = StringWidth(" ANYKEY ")+20
  MaxL=ww
  For i = 1 To k + 1
    m = StringWidth(MessageTxt$(i))
    If m > MaxL Then MaxL = m
  Next 

  ;create message image box
  H = (k+3) * (FontH + 6)+8
  w =  MaxL  + 40
  mhandle=CreateImage(w,H)
  mBuff=ImageBuffer(mHandle)
  SetBuffer(mBuff)

  ;draw message graphics
  Color 255,0,0
  Rect 0,0, w, H,1
  Color 125,125,125
  Rect 2, 2, w-4 , H-4
  Color 0,0,0
  For i = 1 To k + 1
    Text  w/2,  i * (FontH+6) - 4, MessageTxt$(i),1,0
  Next 

  ;create anykey button to close message before time expires
  If msecs <> 0  Then
		x1= (w-StringWidth(" Any Key "))/2
		y1=H-FontH-14
    ButtonBox(x1,y1,0,0," Any Key ",fnt,red,black,0)
  EndIf

  SetBuffer BackBuffer()
  DrawBlock	img,0,0
  DrawBlock mHandle, bx,by
  Flip

  If msecs = 0 
		;message stays on screen only while button is down
		Repeat
		  DrawBlock	img,0,0
		  DrawBlock mHandle, bx,by
		  DrawImage MouseImage,bx+100,by+100
		  Flip
    Until MouseDown(1)+MouseDown(2)=0
  Else
    t1 = MilliSecs() 
		;Flush keys and wait for mouse release
		FlushKeys()
		Repeat: Until Not(MouseDown(1))
		Repeat
		  DrawBlock	img,0,0
		  DrawBlock mHandle, bx,by
		  DrawImage MouseImage,MouseX(),MouseY()
		  Flip
	    If GetKey() Then Exit
	    If MouseDown(1) Then 
				While MouseDown(1): Wend
				Exit 
			EndIf
		Until MilliSecs() - t1 > msecs
  End If
  ;leave passed screen image on backbuffer
  DrawBlock	img,0,0
  FreeImage mhandle  ;release message image block

End Function

;*************************************************************************

Function EditTextBox$(x,y,w,fnt,r$,mask$,Bcolor,Fillcolor,Textcolor)
	;stand alone text box editor
	;Uses front buffer
	;Restores Front buffer on exit
	;resets Buffer to previous buffer on exit
	
	;restore info
	current_buffer=GraphicsBuffer()
	If fnt<>0 Then SetFont fnt
	fw=FontWidth()+2
	h=FontHeight()+2
	tempImg=CreateImage(w,H)
	SetBuffer FrontBuffer()
	GrabImage tempImg,x,y
	r0$=r$
	
	pos=Len(r$)  ;location of cursor relative to text
	xpos=pos	 ;old cursor position
	;draw border and set clipping so everthing stays inside border
	ColorSet(Bcolor)
	Rect x,y,w,h
	Viewport x+1,y+1,w-2,h-2
	Origin x+1,y+1
	
	Repeat
	  ;calc cursor and text positions
	  x0= StringWidth(Left$(r$,pos))
	  cpos=x0  ;location of cursor relative to screen
	  If cpos>w-Fw Then cpos =w-Fw
	
	  ;draw text  
	  colorSet(Fillcolor)
	  Rect 0,0,w-2,h-2
	  colorSet(textColor)
	  If fnt<>0 Then SetFont fnt
	  Text cpos-x0,1,r$
	  Line cpos+1,2,cpos+1,h-2

    ;get keyboard input
	 	Repeat
			action=False
			;check for end of editing
			If KeyDown(1) Then r$=r0$:done=True ;esc
			If KeyDown(156) Then done=True		;enter
			If KeyDown(28)  Then done=True		;enter
			;check deletions
			If KeyDown(14) Then      			;backspace
			  If pos>0 Then 
			 	r$=Left$(r$,pos-1)+Right$(r$,Len(r$)-pos)
				pos=pos-1
			  EndIf
			EndIf
			If KeyDown(211) Then      			;Delete
			  If pos<Len(r$) Then 
			 	r$=Left$(r$,pos)+Right$(r$,Len(r$)-pos-1)
				Action=True	 ;needed because position hasn't changed
			  EndIf
			EndIf
			
			;check keypad /ignores number lock
			keypad$=""
			If KeyDown(82) Then keypad$="0"
			If KeyDown(79) Then keypad$="1"
			If KeyDown(80) Then keypad$="2"
			If KeyDown(81) Then keypad$="3"
			If KeyDown(75) Then keypad$="4"
			If KeyDown(76) Then keypad$="5"
			If KeyDown(77) Then keypad$="6"
			If KeyDown(71) Then keypad$="7"
			If KeyDown(72) Then keypad$="8"
			If KeyDown(73) Then keypad$="9"
			If Len(keypad$) Then action=True
			
			;check for cursor movement
			If KeyDown(203) Then 				;left arrow
			  If pos>0 Then pos=pos-1 
			EndIf   
			If KeyDown(205) Then				;right arrow
			  If pos<Len(r$) Then pos=pos+1
			EndIf
			If KeyDown(199) Then pos=0 			;home
			If KeyDown(207) Then pos=Len(r$)	;end
			If pos<>xPos Then
			  action=True
			  xpos=pos
			EndIf
			
			KeyASC=GetKey()
	  	If (KeyASC>31 And KeyASC<127) Then c$=Chr$(KeyASC) Else c$=Keypad$
	
	  	If Len(c$) Then
				If KeyDown(58) Then c$=Upper$(c$)	;caps?
				If KeyDown(54) Then c$=Upper$(c$)	;Rshift
				If KeyDown(42) Then c$=Upper$(c$)	;Lshift
	    	If mask$="any" Or Instr(mask$,c$) Then
					If pos=Len(r$) Then 
			  		r$=r$+c$
				  ElseIf pos=0 Then
				  	r$=c$+r$
				  Else
				  	r$=Left$(r$,pos)+c$+Right$(r$,Len(r$)-pos)
				  EndIf
				  pos=pos+1
				EndIf
		 		action= True
		 		FlushKeys()
	   	EndIf
	  	Delay 60
	
	  Until action Or done
	Until done
	
	Viewport 0,0,GraphicsWidth(),GraphicsHeight()
	Origin 0,0
	DrawBlock tempImg,x,y
	FreeImage tempImg
	SetBuffer current_buffer
	Return r$
	
End Function

;*************************************************************************

Function TextBox(x,y,w,h,r$,fnt,b,f,t,c)
	;draws text inside a define box on current buffer
	If fnt<>0 Then SetFont fnt
	If w=0 Then w=StringWidth(r$)+4
	If h=0 Then h=FontHeight()+4
	
 	ColorSet(B)		;Border
 	Rect x,y,w,h
	colorSet(F)		;Fill
	Rect x+1,y+1,w-2,h-2
	colorSet(T)		;Text
	If c=0 Then
	  Text x+2,y+2,r$
	Else
	  Text x+1+w/2,y-1+h/2,r$,1,1
	EndIf
End Function

;*************************************************************************

Function Error_Msg(e$)
	SetBuffer FrontBuffer()
	Color 255,255,255
	Rect 80,80,300,100
	Color 255,0,0
	Text 100,100,e$
	Text 100,140,"Press any key to continue"
	WaitKey()
	SetBuffer BackBuffer()
End Function	

Function pause(t)
	t0=MilliSecs()
	FlushKeys
	While MilliSecs()-t0<t
		For i=1 To 237
			If KeyDown(i) Then Return False
		Next
	Wend 
	Return True
End Function

Function MiniMax(V,minV,maxV)
	If V<minV Then Return minV
	If V>maxV Then Return maxV
	Return V
End Function


Function Max(a,b)
	If a>b Then Return a Else Return b
End Function

Function MIN(a,b)
	If a<b Then Return a Else Return b
End Function

Function colorSet(c)
	Color Pal(c,0),Pal(c,1),Pal(c,2)
End Function


Function ColorDefine(r,g,b,n)
	pal(n,0)=r
	pal(n,1)=g
	pal(n,2)=b
End Function

Function ButtonBox(x,y,w,h,r$,fnt,fillcolor,txtcolor,Pressed)
	;draws text inside a define box on current buffer
	If fnt<>0 Then SetFont fnt
	If w=0 Then w=StringWidth(r$)
	If h=0 Then h=FontHeight()+8
	
 	ColorSet(White)
 	Rect x,y,w,h
	colorSet(fillcolor)		;Fill
	Rect x+1,y+1,w-2,h-2
	colorSet(txtcolor)		;Text
	Text x+w/2,y-1+h/2,r$,1,1
	ColorSet(Black)
	If Pressed 
	  Line x,y,x+w,y: Line x,y,x,y+h
	Else
	  Line x+1,y+h-1,x+w,y+h-1: Line x+w-1,y+1,x+w-1,y+h
	EndIf
	
End Function


Function SliderBackground(w,h)
  ;draws to current buffer and dosn't cleanup
	;Set origin before calling
  colorset(white)
  Rect 0,0,w,h
  colorset(LtGray)
  For y=0 To h
		x0= y Mod 2
	 	For x=x0 To w Step 2
		  Plot x,y
		Next
  Next
	;arrow box
  colorset(white)
	Rect 0,0,SliderWidth,SliderWidth
	Rect w-SliderWidth,h-SliderWidth,SliderWidth,SliderWidth
	colorset(black)
	Rect 1,1,SliderWidth-1,SliderWidth-1
	Rect 1+w-SliderWidth,1+h-SliderWidth,SliderWidth-1,SliderWidth-1
  colorset(LtGray)
	Rect 1,1,SliderWidth-2,SliderWidth-2
	Rect 1+w-SliderWidth,1+h-SliderWidth,SliderWidth-2,SliderWidth-2
	colorset(black)
  colorset(red)
	If h>w Then
		Fort_Triangle(SliderWidth/2,SliderWidth-4,SliderWidth-5,7)
		Fort_Triangle(SliderWidth/2,h-SliderWidth+4,SliderWidth-5,10)
	Else
		Fort_Triangle(SliderWidth-4,SliderWidth/2,SliderWidth-5,1)
		Fort_Triangle(w-SliderWidth+4,SliderWidth/2,SliderWidth-5,4)
	EndIf

  shand=CreateImage(w,h)
  GrabImage shand,0,0
	Return shand
	
End Function


Function Fort_Triangle(x,y,h,d)

	;x,y  base center

	Select d
	Case 1	;left
		For i=1 To h
			r=i*100/173
			x0=x-h+i
			Line x0,y-r,x0,y+r
		Next
	Case 2	;right
		y=y-h*50/173
		x=x-h/2
		For i=1 To h
			r=i*100/173
			x0=x+h-i
			Line x0,y-r,x0,y+r
		Next
	Case 3	;left
		y=y-h*50/173
		x=x+h/2
		For i=1 To h
			r=i*100/173
			x0=x-h+i
			Line x0,y-r,x0,y+r
		Next
	Case 4	;right
		For i=1 To h
			r=i*100/173
			x0=x+h-i
			Line x0,y-r,x0,y+r
		Next
	Case 5	;SE
		y=y+h*50/173
		x=x+h/2
		For i=1 To h
			r=i*100/173
			x0=x-h+i
			Line x0,y-r,x0,y+r
		Next
	Case 6
		y=y+h*50/173
		x=x-h/2
		For i=1 To h
			r=i*100/173
			x0=x+h-i
			Line x0,y-r,x0,y+r
		Next
	Case 7	;updown   N
		For i=1 To h
			r=i*100/173
			y0=y-h+i
			Line x-r,y0,x+r,y0
		Next
	Case 8	;NE
		y=y-h/2
		x=x+h*50/173
		For i=1 To h
			r=i*100/173
			y0=y+h-i
			Line x-r,y0,x+r,y0
		Next
	Case 9
		y=y+h/2
		x=x+h*50/173
		For i=1 To h
			r=i*100/173
			y0=y-h+i
			Line x-r,y0,x+r,y0
		Next
	Case 10		;S
		For i=1 To h
			r=i*100/173
			y0=y+h-i
			Line x-r,y0,x+r,y0
		Next
	Case 11
		y=y+h/2
		x=x-h*50/173
		For i=1 To h
			r=i*100/173
			y0=y-h+i
			Line x-r,y0,x+r,y0
		Next
	Case 12
		y=y-h/2
		x=x-h*50/173+1
		For i=1 To h
			r=i*100/173
			y0=y+h-i
			Line x-r,y0,x+r,y0
		Next
	Default
	End Select

End Function


Function MouseWait()
	;wait until mouse release
	While MouseDown(1): Wend
	;wait for mouse press
	Repeat
		;DrawBlock ScreenImage,0,0
		;screen_Update(mx,my)
		;DrawImage MouseImage, mx,my
		;Flip
	Until MouseDown(1)
	;wait until mouse release
	While MouseDown(1): Wend
End Function


Function Fill_Form(img)

	Focus_Find(9)
	Sform=Form_Image(9)
	
	Repeat
		ObjIndex=form_control(9,Sform,img)
		Select ReturnText$(ObjIndex)
		Case "CAN"
			Exit
		Case "DONE"
			Exit
		Case "SHOW"
			obj(ObjIndex,8)=False
		End Select
	Until KeyDown(1)
	
	While KeyDown(1):Wend
	Repeat: Until Not(MouseDown(1))
	obj(ObjIndex,8)=False
	FreeImage Sform
	Return 

End Function