;Buttons
Global nButtons=2,Button_Y=4,Button_w=82,Button_X=ScrnW-100
Dim ButtonText$(nButtons)

;Flood Fill globals
Global fillpattern,WatchFlood=False
Global currentP,LastP,ActiveP,MaxP=2000
Dim PList(1)
Dim dirX(4),dirY(4)
diry(1)=-1:dirx(2)= 1:dirY(3)= 1:dirx(4)=-1



Function Button_DrawButtons()
	SetFont FontHand(0)
	h=FontHeight()+2
	For i=1 To nButtons
	  x=Button_X
	  y=Button_Y+(i-1)*(FontHeight()+8)
	  ;Pressed=False If Button=i Then Pressed=True
	  ButtonBox(x,y,Button_W,h,ButtonText$(i),FontHand(0),red,black,Pressed)
	Next
End Function


Function divide(x0,y0, x1,y1, x2,y2, w0,w2,counter) ; curve control point is middle 
	;RobinS Quadratic Bezier Curve Function Posted 12-12-2000 19:19 
	If counter = 0
		Draw_Line(x0,y0,x2,y2,w0,w2)
		Return True 
	Else 
		xsplit = (x0+x1)/2 
		ysplit = (y0+y1)/2 
		xsplit2 = (x1+x2)/2 
		ysplit2 = (y1+y2)/2 
		sendX = (xsplit + xsplit2)/2 
		sendY = (ysplit + ysplit2)/2 
		wsp1=(w0+w2)/2
		divide (x0,   y0,   xsplit,  ysplit,  sendX,sendY,w0,  wsp1,counter-1) 
		divide (sendX,sendY,xsplit2, ysplit2, x2,   y2,   wsp1,w2,  counter-1) 
		Return False 
	EndIf 
End Function


Function Draw_Line(x0,y0,x2,y2,w0,w2)
	ww=(w0+w2)/2
	ww2=ww/2
	If ww=0 Then
	  Line x0,y0,x2,y2
	  Return
	EndIf
	dx#=x2-x0
	dy#=y2-y0
	r=Sqr#(dx*dx+dy*dy)
	xFact#=dx/r			;sin()
	yfact#=dy/r 		;cos()
	For i=0 To r
		x=i*xFact+x0
		y=i*yfact+y0
		Rect x-ww2,y-ww2,ww,ww
	Next

End Function


Function Draw_Rect(x0,y0,x2,y2,Fill)
  If x2>x0
	w=x2-x0
	If y2>y0 Then Rect x0,y0,w,y2-y0,fill Else Rect x0,y2,w,y0-y2,fill
  Else
  	w=x0-x2
	If y2>y0 Then Rect x2,y0,w,y2-y0,fill Else	Rect x2,y2,w,y0-y2,fill
  EndIf
End Function




Function Draw_Loop(x0,y0,x2,y2)
	dx=x2-x0
	dy=y2-y0
	a=ATan2(dx,dy)
	a0=a-90
	a2=a+90
	r=30
	x1=r*Sin(a0)
	y1=r*Cos(a0)

	Line x0+x1,y0+y1,x2+x1,y2+y1
	Line x0-x1,y0-y1,x2-x1,y2-y1
	Draw_ARC(x0,y0,-r,a0,a2)
	Draw_ARC(x2,y2,r,a0,a2)

	r=29
	x1=r*Sin(a0)
	y1=r*Cos(a0)

	Line x0+x1,y0+y1,x2+x1,y2+y1
	Line x0-x1,y0-y1,x2-x1,y2-y1
	Draw_ARC(x0,y0,-r,a0,a2)
	Draw_ARC(x2,y2,r,a0,a2)

End Function


Function Draw_ARC(x0,y0,r,a1,a2)
		
	d=10*Sgn(a2-a1)
	If d=0 Then Return
	x2=x0+r*Sin(a1)
	y2=y0+r*Cos(a1)
	Repeat
		a1=a1+d
		x=x0+r*Sin(a1)
		y=y0+r*Cos(a1)
		Line x2,y2,x,y
		x2=x:	y2=y
	Until a1=a2
	Return

End Function


Function BackGround_Make()
	If background>0 Then FreeImage background
	background=CreateImage(winW,winH)
	SetBuffer ImageBuffer(background)
	If Backgroundfill<0 Then
		ColorSet(Dcolor)
		Rect 0,0,WinW,WinH
	Else
		TileBlock fillpattern,0,0,Backgroundfill
	EndIf
	SetBuffer BackBuffer()
End Function




;Help Functions ****************************************************

Function MapViewPort(v)
  If v=1 Then
		Viewport WinX,WinY,WinW,WinH
		Origin WinX-MapX,WinY-MapY
  Else
		Viewport 0,0,ScrnW,ScrnH
		Origin 0,0
  EndIf
End Function


Function ScrollMapKeys(img,Scroll1,Scroll2)
	;MapX and MapY are global
	MapX2 = MapX
	MapY2 = MapY

	If KeyDown(203) Then mapX=mapX-Scroll1    	;left arrow
	If KeyDown(205) Then mapX=mapX+Scroll1    	;right arrow
	If KeyDown(15) Then 					;tab key
		;is shift key down too?
		If KeyDown(42) Then MapX=MapX-Scroll2 Else MapX=MapX+Scroll2
	EndIf
 	If KeyDown(200) Then mapY=mapY-Scroll1   	;up arrow
	If KeyDown(208) Then mapY=mapY+Scroll1    	;down arrow
	If KeyDown(201) Then mapY=mapY-Scroll2   	;page up
	If KeyDown(209) Then mapY=mapY+Scroll2   	;page down
	If KeyDown(199) Then mapY=0:mapX=0   	;home
	If KeyDown(207) Then 					;end
	  mapY=MaxMapY:      mapX=MaxMapX  
	EndIf
	
	If MapX<0 Then MapX=0
	If MapY<0 Then MapY=0
	If MapX>MaxMapX Then MapX=MaxMapX
	If MapY>MaxMapY Then MapY=MaxMapY
	If MapX<>MapX2 Or MapY<>MapY2
	  ;redraw map only if necessary
	  Screen_Imagedraw(img,0)
	  Return True
	EndIf
	Return False
	
End Function


Function Scrn2MapX(x)
  Return x+mapX-WinX
End Function


Function Scrn2MapY(y)
  Return y+mapY-WinY
End Function


Function Sliderss____________()
End Function


Function SliderSize(VisbleRange,TotalRange,SliderRange)
	If SliderRange=0 Then Return SliderRange
	If TotalRange=0 Then Return SliderRange
	If VisbleRange=0 Then Return SliderRange
	Return 	SliderRange*VisbleRange/TotalRange
End Function


Function Sliders_Create()

	MaxMapX=cellW * MapsizeX - WinW
	MaxMapY=cellH * MapsizeY - WinH

	s=sliderwidth
	;v slider
	WinVS=WinObj_Load(1,winX+winW,winY+2*s,s,winH-4*s,1,0,0)
	;h slider
	WinHS=WinObj_Load(1,winX+2*s,winY+winH,winW-4*s,s,2,0,0)
	;D up
	WinObj_Load(1,winX+winW,winY,s,s,3,0,5)
	;up
	WinObj_Load(1,winX+winW,winY+s,s,s,3,0,1)
	;D down
	WinObj_Load(1,winX+winW,winY+winH-s,s,s,3,0,6)
	;down
	WinObj_Load(1,winX+winW,winY+winH-2*s,s,s,3,0,2)
	;D left
	WinObj_Load(1,winX,winY+winH,s,s,3,0,7)
	WinObj_Load(1,winX+s,winY+winH,s,s,3,0,3)
	;D right
	WinObj_Load(1,winX+winW-s,winY+winH,s,s,3,0,8)
	WinObj_Load(1,winX+winW-2*s,winY+winH,s,s,3,0,4)
	
	For i=1 To nWinObj
		WinObj_Make(i)
	Next

End Function


Function SliderCreate(w,h,c)
	shand=CreateImage(w,h)
	SetBuffer ImageBuffer(shand)
 	ColorSet(White)	;outside edge
	Rect 0,0,w,h
	colorSet(c)		;Fill
	Rect 1,1,w-2,h-2
	ColorSet(Black)
  Line 1,h-1,w,h-1: Line w-1,1,w-1,h
	SetBuffer BackBuffer()
	Return shand
End Function


Function SliderPosition(Pos,VisbleRange,TotalRange,SliderRange)
	If SliderRange=0 Then Stop
	If TotalRange =0 Then Stop
	If VisbleRange=0 Then Stop
	SLiderSize=SliderRange * VisbleRange/TotalRange
	SliderPos=Pos*(SliderRange-SLiderSize)/(TotalRange-VisbleRange)
	Return SliderPos	
End Function


Function Slider_move(n)

	If Not MouseDown(1) Then Return


	If WinObj(n,5)=1 Then
		r=WinObj(n,4)-WinObj(n,9)	;slider area- slider size
		my=MouseY()-WinObj(n,8)
		While MouseDown(1)
			dy=MiniMax(MouseY()-WinObj(n,2)-my,0,r)
	  	MapY=dy*MaxMapY/r
			Screen_ImageDraw(screenimage,0)
			DrawBlock screenimage,0,0
			DrawImage MouseImage, WinObj(n,1)+4, MouseY()
			Flip
		Wend
	ElseIf WinObj(n,5)=2 Then
		r=WinObj(n,3)-WinObj(n,9)	;slider area- slider size
		mx=MouseX()-WinObj(n,8)
		While MouseDown(1)
			dx=MiniMax(MouseX()-WinObj(n,1)-mx,0,r)
	  	MapX=dx*MaxMapX/r
			Screen_ImageDraw(screenimage,0)
			DrawBlock screenimage,0,0
			DrawImage MouseImage, MouseX(),WinObj(n,2)+4
			Flip
		Wend
	EndIf

End Function


Function WIN_CONTROL(mx,my)

	If Not MouseDown(1) Then Return False

  Mapx2=MapX
  MapY2=MapY
	Control_event=False

	For n=1 To nWinObj
	  If RectsOverlap(mx,my,1,1,WinObj(n,1),WinObj(n,2),WinObj(n,3),WinObj(n,4))
			WIN_Process(n,mx,my)
			Control_event=True
			Exit
		EndIf
	Next

  If MapX<0 Then MapX=0
  If MapY<0 Then MapY=0
  If MapX>MaxMapX Then MapX=MaxMapX
  If MapY>MaxMapY Then MapY=MaxMapY
  If MapX<>MapX2 Or MapY<>MapY2
		;redraw map only if necessary
		Screen_ImageDraw(screenimage,0)
  EndIf
	Return Control_event
	
End Function


Function WIN_Process(n,mx,my)

	Select WinObj(n,5)	;object type
	Case 1	;V Slider
		dy=My-WinObj(n,2)
		r=WinObj(n,4)-WinObj(n,9)	;slider area- slider size
		If mY<WinObj(n,8) Then 
			;above (less than) slider pos
	  	MapY=dy*MaxMapY/r
	  	If dy<3 Then MapY=0
		ElseIf My>WinObj(n,8)+WinObj(n,9) Then
	  	MapY=(dy-WinObj(n,9))*MaxMapY/r
	  	If dy>WinObj(n,4)-3 Then MapY=MaxMapY
		Else
			Slider_move(n)
		EndIf
	Case 2	;H Slider
		dx=Mx-WinObj(n,1)
		r=WinObj(n,3)-WinObj(n,9)	;slider area- slider size
		If mx<WinObj(n,8) Then 
			;above (less than) slider pos
	  	MapX=dx*MaxMapX/r
	  	If dx<3 Then MapX=0
		ElseIf Mx>WinObj(n,8)+WinObj(n,9) Then
	  	MapX=(dx-WinObj(n,9))*MaxMapX/r
	  	If dx>WinObj(n,3)-3 Then MapX=MaxMapX
		Else
			Slider_move(n)
		EndIf
	Case 3	;Scroll arrows
		Select WinObj(n,9)
		Case 1	;up
			mapY=MapY-CellH
		Case 2 	;down
			mapY=MapY+CellH
		Case 3	;left
			mapX=MapX-CellW
		Case 4	;Right
			mapX=MapX+CellW
		Case 5	;Double up
			mapY=MapY-WinH
		Case 6	;Double down
			mapY=MapY+WinH
		Case 7	;Double left
			mapX=MapX-WinW
		Case 8	;Double right
			mapX=MapX+WinW
		End Select
	Case 4	;button
	
	End Select

End Function


Function WinObj_Load(winN,x,y,w,h,t,f8,f9)
	;WinObj(x,i)
	;x	obj index
	;0	Master Window
	;1	x
	;2	y
	;3	w
	;4	h
	;5	Obj type (0=inactive)
	;6	image hand
	;7  aux image hand
	;8	state
	;9  

	nWinObj=nWinObj+1
	WinObj(nWinObj,0)=winN
	WinObj(nWinObj,1)=x
	WinObj(nWinObj,2)=y
	WinObj(nWinObj,3)=w
	WinObj(nWinObj,4)=h
	WinObj(nWinObj,5)=t
	WinObj(nWinObj,8)=f8
	WinObj(nWinObj,9)=f9

	Return nWinObj

End Function


Function WinObj_Make(n)

	;WinObj(n,i)
	;x	obj index
	;0	Master Window
	;1	x
	;2	y
	;3	w
	;4	h
	;5	Obj type (0=inactive)
	;6	image hand
	;7  aux image hand
	;8	state
	;9  

	Select WinObj(n,5)
	Case 1	;V Slider
		;8	slider pos
		;9	slider height
		If WinObj(n,6)>0 Then FreeImage WinObj(n,6)
		WinObj(n,6)=CreateImage(WinObj(n,3),WinObj(n,4))
		SetBuffer ImageBuffer(WinObj(n,6))
	  colorset(white)
	  Rect 0,0,WinObj(n,3),WinObj(n,4)
	  colorset(LtGray)
	  For y=0 To WinObj(n,4)
			x0= y Mod 2
		 	For x=x0 To WinObj(n,3) Step 2
			  Plot x,y
			Next
	  Next
		;create slider button
		;h=slider height * %vievable map
		VSliderSize=(WinObj(n,4))*WinH/(MaxMapY+WinH)
		WinObj(n,9)=VSliderSize 
		If WinObj(n,7)>0 Then FreeImage WinObj(n,7)
		WinObj(n,7)=SliderCreate(WinObj(n,3),WinObj(n,9),LtGray)
	Case 2	;H Slider
		;8 slider pos
		;9 slider width
		If WinObj(n,6)>0 Then FreeImage WinObj(n,6)
		WinObj(n,6)=CreateImage(WinObj(n,3),WinObj(n,4))
		SetBuffer ImageBuffer(WinObj(n,6))
	  colorset(white)
	  Rect 0,0,WinObj(n,3),WinObj(n,4)
	  colorset(LtGray)
	  For y=0 To WinObj(n,4)
			x0= y Mod 2
		 	For x=x0 To WinObj(n,3) Step 2
			  Plot x,y
			Next
	  Next
		;create slider button
		;W=slider width * %vievable map
		HSliderSize=(WinObj(n,3))*WinW/(MaxMapX+WinW)
		WinObj(n,9)=HSliderSize 
		If WinObj(n,7)>0 Then FreeImage WinObj(n,7)
		WinObj(n,7)=SliderCreate(WinObj(n,9),WinObj(n,4),LtGray)
	Case 3	;Arrow button
		;8	pressed
		;9  type
		;10	value change
		If WinObj(n,6)>0 Then FreeImage WinObj(n,6)
		WinObj(n,6)=CreateImage(WinObj(n,3),WinObj(n,4))
		SetBuffer ImageBuffer(WinObj(n,6))
		;draw 3d button
	  colorset(white)
		Rect 0,0,WinObj(n,3),WinObj(n,4)
		colorset(black)
		Rect 1,1,WinObj(n,3)-1,WinObj(n,4)-1
	  colorset(LtGray)
		Rect 1,1,WinObj(n,3)-2,WinObj(n,4)-2

		;draw arrow
	  colorset(black)
		Select WinObj(n,9)
		Case 1	;up
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)*3/4,WinObj(n,4)*2/3,7)
		Case 2 ;down
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)/4,WinObj(n,4)*2/3,10)
		Case 3	;left
			Fort_Triangle(WinObj(n,3)*3/4,WinObj(n,4)/2,WinObj(n,3)*2/3,1)
		Case 4
			Fort_Triangle(WinObj(n,3)/4,WinObj(n,4)/2,WinObj(n,3)*2/3,4)
		Case 5	;double up
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)*9/16,WinObj(n,4)/2,7)
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)*7/8,WinObj(n,4)/2,7)
		Case 6	;double down
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)/8,WinObj(n,4)/2,10)
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)*7/16,WinObj(n,4)/2,10)
		Case 7	;Double left
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)/2,WinObj(n,3)/2,1)
			Fort_Triangle(WinObj(n,3)*7/8,WinObj(n,4)/2,WinObj(n,3)/2,1)
		Case 8	;Double right
			Fort_Triangle(WinObj(n,3)/8,WinObj(n,4)/2,WinObj(n,3)/2,4)
			Fort_Triangle(WinObj(n,3)*7/16,WinObj(n,4)/2,WinObj(n,3)/2,4)
		End Select
		
		;pressed image
		If WinObj(n,7)>0 Then FreeImage WinObj(n,7)
		WinObj(n,7)=CreateImage(WinObj(n,3),WinObj(n,4))
		SetBuffer ImageBuffer(WinObj(n,7))
		colorset(black)
		Rect 0,0,WinObj(n,3),WinObj(n,4)
	  colorset(white)
		Rect 1,1,WinObj(n,3)-1,WinObj(n,4)-1
	  colorset(LtGray)
		Rect 1,1,WinObj(n,3)-2,WinObj(n,4)-2
		
		;draw arrow
	  colorset(red)
		Select WinObj(n,9)
		Case 1	;up
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)*3/4,WinObj(n,4)*2/3,7)
		Case 2 ;down
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)/4,WinObj(n,4)*2/3,10)
		Case 3
			Fort_Triangle(WinObj(n,3)*3/4,WinObj(n,4)/2,WinObj(n,3)*2/3,1)
		Case 4	;right
			Fort_Triangle(WinObj(n,3)/4,WinObj(n,4)/2,WinObj(n,3)*2/3,4)
		Case 5	;double up
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)*9/16,WinObj(n,4)/2,7)
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)*7/8,WinObj(n,4)/2,7)
		Case 6	;double down
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)/8,WinObj(n,4)/2,10)
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)*7/16,WinObj(n,4)/2,10)
		Case 7	;Double left
			Fort_Triangle(WinObj(n,3)/2,WinObj(n,4)/2,WinObj(n,3)/2,1)
			Fort_Triangle(WinObj(n,3)*7/8,WinObj(n,4)/2,WinObj(n,3)/2,1)
		Case 8	;Double right
			Fort_Triangle(WinObj(n,3)/8,WinObj(n,4)/2,WinObj(n,3)/2,4)
			Fort_Triangle(WinObj(n,3)*7/16,WinObj(n,4)/2,WinObj(n,3)/2,4)
		End Select
	Case 4	;button
		x=WinObj(n,1)
		y=WinObj(n,2)
		w=WinObj(n,3)
		h=WinObj(n,4)
		WinObj(n,6)=ButtonBox(x,y,w,h,r$,fonthand(0),gray,black,0)
		WinObj(n,7)=ButtonBox(x,y,w,h,r$,fonthand(0),gray,black,1)
	End Select

	;WinObj(n,i)
	;x	obj index
	;0	Master Window
	;1	x
	;2	y
	;3	w
	;4	h
	;5	Obj type (0=inactive)
	;6	image hand
	;7  aux image hand
	;8	state
	;9  


End Function


Function Fracture(x0,y0,x2,y2,H,Power#, counter)
	;Recursive routine for roughing up a line
	If counter<1
		Line x0,y0,x2,y2
	Else
		F=H :If Rnd(1)>.5 Then F=-H 
		x1=(x0+x2)/2+F
		F=H :If Rnd(1)>.5 Then F=-H 
		y1=(y0+y2)/2+F
		H=H^(power)
		fracture (x0,y0,x1,y1,H,Power,counter-1)
		fracture (x1,y1,x2,y2,H,Power,counter-1)
	EndIf 
End Function


Function Flood_Fill(source,x,y,Pcolor)

	w=ImageWidth(source)-1
	h=ImageHeight(source)-1
	If WatchFlood Then
		SetBuffer FrontBuffer()
		DrawBlock source,0,0
		Color 255,255,255
;		Rect 0,0,w,h,0
	Else
		SBuffer=ImageBuffer(source)
		SetBuffer Sbuffer
	EndIf
	
	Dim PList(maxP)
	currentP=0
	LastP=0
	Plist(LastP)=y Shl 16 + x
	LockBuffer 
	WritePixelFast x,y,PColor

	If WatchFlood Then 
		Repeat
			If WatchFlood Then Delay 0
			If KeyDown(1) Then Exit
		Until Flood_Next(Pcolor,w,h)<1		
		UnlockBuffer
		GrabImage source,0,0
		WaitKey()
		SetBuffer BackBuffer()
	Else
		Repeat
		Until Flood_Next(Pcolor,w,h)<1		
		UnlockBuffer
		SetBuffer BackBuffer()
	EndIf

End Function


Function Flood_Next(PColor,w,h)

	;pull a point off the list of active points
	ActiveP=ActiveP-1
	x0=PList(currentP) And 65535
	Y0=PList(currentP) Shr 16
	;check the four adjacent pixels
	For i=1 To 4
	  x=x0+dirX(i)
	  y=y0+dirY(i)
	  If x<0 
	  ElseIf y<0
	  ElseIf x>W
	  ElseIf y>H
	  ElseIf ReadPixelFast(x,y)=0 Then
			; if blank, color and add to active list
		  WritePixelFast x,y,PColor
			LastP=LastP+1
			ActiveP=ActiveP+1
			If LastP>maxP Then LastP=0   ;wrap around if at end
			Plist(LastP)=y Shl 16 + x	 ;add pixel list
	  EndIf
	Next
	
	;If ActiveP>maxA Then maxA=ActiveP ;for debugging
	
	;set current point to next on list
	currentP=currentP+1
	If currentP>MaxP Then currentP = 0	;if at end wrap around

	Return 	ActiveP	 ;we're done when there's no more active points

End Function

Function Files________________()
End Function

Function FileList_Make(path$,spec$)
	;spec$ refers to the file extension e.g. txt
	dir = ReadDir(path$) 
	If dir=0 Then Return 0		;bad directory name
	
	;first read all directories into file list
	dir = ReadDir(path$) 
	fnam$=NextFile$(dir) 
	While fnam$<>"" 
		If  FileType(path$+fnam$)=2 Then
			cnt=cnt+1 
			fil$(cnt,0)=fnam$ 
			fil$(cnt,1)="2"
			fil$(cnt,2)="DIR"
			If fnam$="." Then cnt=cnt-1
		EndIf 
		fnam$=NextFile$(dir) 
	Wend 
	CloseDir(dir) 

	;read all the files in the target directory into fil$()
	dir = ReadDir(path$) 
	fnam$=NextFile$(dir) 
	spec$=Upper$(spec$)
	While fnam$<>"" 
		If FileType(path$+fnam$)=1 Then
	 		ext$=Upper$(Right$(fnam$,3))
			If  spec="*"  Then
				cnt=cnt+1 
				fil$(cnt,0)=fnam$ 
				fil$(cnt,2)=(FileSize(path$+fnam$)/1024) +"K" 
				fil$(cnt,1)=1 
			ElseIf Instr(ext$,spec$)<>0 Then 
				cnt=cnt+1 
				fil$(cnt,0)=fnam$ 
				fil$(cnt,2)=(FileSize(path$+fnam$)/1024) +"K" 
				fil$(cnt,1)=1
			EndIf 
		EndIf 
		fnam$=NextFile$(dir) 
	Wend 
	CloseDir(dir) 
	Return cnt
End Function


Function File_Name_extract$(f$)
	For i=Len(f$) To 1 Step -1
		If Mid$(f$,i,1)="\" Then Return Right$(f$,Len(f$)-i)
	Next
	Return f$
End Function


Function File_Dir_extract$(f$)
	For i=Len(f$) To 1 Step -1
		If Mid$(f$,i,1)="\" Then Return Left$(f$,i)
	Next
	Return ""
End Function


Function File_Select$(title$,Dir$,ext$,img)

	mChar=25
	fn1=Form_Object(14,"FRM14",-1,-1)
	objText$(fn1)=title$
	fn2=Form_Object(14,"EXT",-1,-1)
	objText$(fn2)=ext$
	If Right$(dir$,1)<>"\" Then dir$=dir$+"\"	
	fn3=Form_Object(14,"DIR",-1,-1)
	objText$(fn3)=dir$
	If Len(dir$)>mChar Then objText$(fn3)=".."+Right$(dir$,mChar-2)
	fn4=Form_Object(14,"FILENAME",-1,-1)
	objText$(fn4)=""
	fn5=Form_Object(14,"LIST",-1,-1)

	Inputform=files_Update(dir$,ext$,fn4,fn5)			
		
	Repeat
		;get values of form
		ObjIndex=form_control(14,Inputform,img)
		Select ReturnText$(ObjIndex)
		Case ""
		Case "EXT"
			ext$=objText$(ObjIndex)
			FreeImage Inputform
			Inputform=files_Update(dir$,ext$,fn4,fn5)			
		Case "CDDIR"
			If fil$(obj(fn5,6),1)=2 Then 
				If fil$(obj(fn5,6),0)=".."
					k=Len(dir$)-1
					If k<1 Then k=1
					While Mid$(dir$,k,1)<>"\"
						k=k-1
						If k=1 Then dir$="\":Exit
					Wend
					dir2$=Left$(dir$,k)	
				Else
					dir2$=dir$+fil$(obj(fn5,6),0)+"\"
				EndIf
				d=FileType(dir2$)
				If d=2 Then
					dir$=dir2$
					If Len(dir$)>mChar Then 
						objText$(fn3)=".."+Right$(dir$,mChar-2)
					Else
						objText$(fn3)=dir$
					EndIf
					FreeImage Inputform
					Inputform=files_Update(dir$,ext$,fn4,fn5)			
				EndIf
			EndIf
			obj(ObjIndex,8)=False
		Case "FILENAME"
		Case "LIST"
			If MilliSecs()-t0<200 Then 
				If SND4 Then PlaySound SND4
				If fil$(obj(fn5,6),1)=2 Then 
					If fil$(obj(fn5,6),0)=".."
						k=Len(dir$)-1
						If k<1 Then k=1
						While Mid$(dir$,k,1)<>"\"
							k=k-1
							If k=1 Then dir$="\":Exit
						Wend
						dir2$=Left$(dir$,k)	
					Else
						dir2$=dir$+fil$(obj(fn5,6),0)+"\"
					EndIf
					d=FileType(dir2$)
					If d=2 Then
						dir$=dir2$
						If Len(dir$)>mChar Then 
							objText$(fn3)=".."+Right$(dir$,mChar-2)
						Else
							objText$(fn3)=dir$
						EndIf
						FreeImage Inputform
						Inputform=files_Update(dir$,ext$,fn4,fn5)			
					EndIf
				EndIf
			EndIf 
			objText$(fn4)=Dlist$(obj(fn5,6))
			If SND5 Then PlaySound SND5
			While MouseDown(1):Wend
			t0=MilliSecs()
		Case "CAN"
			FreeImage Inputform
			obj(ObjIndex,8)=False
			Return ""
		Case "DONE"
			FreeImage Inputform
			obj(ObjIndex,8)=False
			Return dir$+objText$(fn4)
		End Select 
	Forever

End Function


Function Files_Update(dir$,ext$,n4,n5)			
	nFiles=FileList_Make(dir$,ext$)
	For i=1 To nFiles
 		If fil$(i,1)=2 Then
	 		Dlist$(i)=Upper$(fil$(i,0))+"\"
		Else
	 		Dlist$(i)=Lower$(fil$(i,0))
		EndIf
	Next 
	objText$(n4)=""
	obj(n5,8)=nFiles
	obj(n5,5)=0
	obj(n5,6)=0
	Return Form_Image(14)
End Function


Function Tools________________()
End Function


Function Clamp(x,x0,x2)
	If x<x0 Then Return x0
	If x>x2 Then Return x2
	Return x
End Function


Function smallest(a,b,c)
	If a>b Then a=b
	If a>c Then a=c
	Return a
End Function


Function Width(a,b,c)
	d=a
	If d<b Then d=b
	If d<c Then d=c
	
	If a>b Then a=b
	If a>c Then a=c
	
	Return d-a
End Function


Function Limit(xy,xy0,wh)
	If xy<xy0 Then Return xy0
	If xy>xy0+wh Then Return xy0+wh
	Return xy
End Function 

	
Function MiniMax(V,minV,maxV)
	If V<minV Then Return minV
	If V>maxV Then Return maxV
	Return V
End Function

Function Load_Message(t$)

	If Len(t$)=0 Then
	Else
		LoadTextLines=LoadTextLines+1	;global
		LoadText$(LoadTextLines)=t$
	EndIf

	If screenimage=0 Then Return

	SetBuffer ImageBuffer(screenimage)
	Color 0,0,0
	Rect 0,0,scrnW,scrnH
	Color 255,255,255
	If fonthand(0)>0 Then SetFont fonthand(0)
	h=FontHeight()+2
	x=20
	k=LoadTextLines-Int(scrnH/h)
	If k<0 Then k=0
	For i=k To LoadTextLines
		Text x,h*(i-k),LoadText$(i-k)
	Next

	SetBuffer BackBuffer()
	DrawBlock screenimage,0,0
	Flip
	Return LoadTextLines
End Function


