;Fonts
Global nFonts=1
Dim FontHand(6),FontName$(6),FontFlags(6),FontObj(6)
;Sound
Global SND1,SND2,SND3,SND4,SND5
Global MsgFont,MenuFnt,MenuWidth,MenuHeight
Global MouseImage,MousePointer,MouseMover


Function Setup_Graphics()
	;need to create these now in case of error messages
	ScreenImage=CreateImage(scrnW,scrnH)
	MaskImage ScreenImage,125,125,125
	Restore pointerdata
	mouseImage=LoadMouse()
	MousePointer=MouseImage
	Restore movepointerdata
	MouseMover=LoadMouse()

	FontHand(0)=LoadFont("Times New Roman",18,1)	;must be after graphics command
	FontHand(1)=LoadFont("Arial",12)
	FontHand(2)=LoadFont("Arial", 8)
	FontHand(3)=LoadFont("Arial",18)
	FontHand(4)=LoadFont("Times New Roman",12)
	FontHand(5)=LoadFont("Times New Roman",36)
	FontHand(6)=LoadFont("Arial",10)

	MsgFont=FontHand(0)
	MenuFnt=FontHand(0)
	MenuWidth=FontWidth()*12
	MenuHeight=FontHeight()+6
	
	SetFont FontHand(0)
	
End Function


Function Setup_Colors()
	ColorDefine(0,0,0,black)
	ColorDefine(255,255,255,white)
	ColorDefine(255,0,0,red)
	ColorDefine(0,255,0,green)
	ColorDefine(0,0,255,blue)
	ColorDefine(100,100,100,gray)
	ColorDefine(200,200,200,LtGray)
	ColorDefine(255,255,0,yellow)
	ColorDefine(0,0,200,majRiv)
	ColorDefine(100,100,255,MinRiv)
	ColorDefine(50,150,50,Dcolor)	;background color for map
	ColorDefine(0,0,0,TColor)			;text color
	ColorDefine(0,0,0,MaskC)			;mask color for overlay tiles
	ColorDefine(0,0,0,HexNumColor)
	ColorDefine(255,0,0,HEXC)

End Function


Function Setup_Sound()
	d$=""
	If FileType(d$)=0 Then d$=""
	s$=d$+"mtruc.wav"
	SND4=LoadSound(s$)
	If SND4=0 Then message(s$+" not found",2000,screenimage)
	s$=d$+"mClick.wav"
	SND5=LoadSound(s$)
	If SND5=0 Then message(s$+" not found",2000,screenimage)
End Function


Function Setup_Forms()

	c$="White   Red     Green   Blue    Gray    LtGray  Yellow  DarkBlueLt Blue Black   Color11 Color12 Color13 Color14 "
	n$="123456781234567812345678123456781234567812345678123456781234567812345678123456781234567812345678123456781234567812345678"

	Tot_obj=0
	Dim obj(max_obj,9),objText$(max_obj),Form(FormsMax,MaxDialogItems)

	;Form 0: Master Properties
	fw=260
	x1=5:	x2=100
	obj_assign(0,0,scrnW-fw-4,100,fw,250,white,ltgray ,FontHand(0),2,"","")
	obj_assign(0,9,0,0,fw-1,20,Black,Blue,MenuFnt,2," Master Form Properties ","FRM0")

	;sliders slider labels
	obj_assign(0,1,x1, 30, 100,20,Black,False ,FontHand(0),0,"X Pos","")
	MF(0,1)=obj_assign(0,7,x2, 30, 100,14,True,0,scrnW-fw-100,0,"","XPOS")
	
	obj_assign(0,1,x1, 50, 100,20,Black,False ,FontHand(0),0,"Y Pos","")
	MF(0,2)=obj_assign(0,7,x2, 50, 100,14,True,0,ScrnH-100,0,"","YPOS")
	
	obj_assign(0,1,x1, 70, 100,20,Black,False ,FontHand(0),0,"Width","")
	MF(0,3)=obj_assign(0,7,x2, 70, 100,14,True,0,ScrnW-100,0,"","W")
	
	obj_assign(0,1,x1, 90, 100,20,Black,False ,FontHand(0),0,"Height","")
	MF(0,4)=obj_assign(0,7,x2, 90, 100,14,True,0,ScrnH-100,0,"","H")
	
	obj_assign(0,1,x1,110, 100,20,Black,False ,FontHand(0),0,"Border","")
	MF(0,5)=obj_assign(0,12,x2,110, 100,18,14,8,FontHand(0),0,c$,"BC")

	obj_assign(0,1,x1,130, 100,20,Black,False ,FontHand(0),0,"Inside","")
	MF(0,6)=obj_assign(0,12,x2,130, 100,18,14,8,FontHand(0),0,c$,"INC")
	
	obj_assign(0,1,x1,150, 100,20,Black,False ,FontHand(0),0,"Font","")
	MF(0,7)=obj_assign(0,7,x2,150, 100,14,True,0,5,0,"","FONT")
	
	obj_assign(0,1,x1,170, 100,20,Black,False ,FontHand(0),0,"Border W","")
	MF(0,8)=obj_assign(0,7,x2,170, 100,14,True,-1,10,0,"","SAT")
	
	obj_assign(0,1,x1,190, 100,20,Black,False ,FontHand(0),0,"Text","")
	MF(0,9)=obj_assign(0,6,x2,190, 100,18,Black,white,FontHand(0),False,"","OBTEXT")

	;buttons
	obj_assign(0,3, 10,220,60,20,gray,white,FontHand(0),False,"Cancel","CAN")
	obj_assign(0,3,110,220,60,20,gray,white,FontHand(0),False,"Done","DONE")

	Focus_Find(0)
	MF(0,10)=Form_Image(0)


	;Form 1: Text
	n=1: fw=260

	obj_assign(n,0,scrnW-fw-4,100,fw,250,white,ltgray ,FontHand(0),2,"","")
	obj_assign(n,9,0,0,fw-1,20,Black,Blue,MenuFnt,2," Text Object Properties ","FRM1")
	;sliders slider labels
	
	obj_assign(n,1,x1, 30, 100,20,Black,False ,FontHand(0),0,"X Pos","")
	MF(n,1)=obj_assign(n,7,x2, 30, 100,14,True,0,scrnW-fw-100,0,"","XPOS")
	
	obj_assign(n,1,x1, 50, 100,20,Black,False ,FontHand(0),0,"Y Pos","")
	MF(n,2)=obj_assign(n,7,x2, 50, 100,14,True,0,ScrnH-100,0,"","YPOS")
	
	obj_assign(n,1,x1, 70, 100,20,Black,False ,FontHand(0),0,"Width","")
	MF(n,3)=obj_assign(n,7,x2, 70, 100,14,True,0,ScrnW-100,0,"","W")
	
	obj_assign(n,1,x1, 90, 100,20,Black,False ,FontHand(0),0,"Height","")
	MF(n,4)=obj_assign(n,7,x2, 90, 100,14,True,0,ScrnH-100,0,"","H")
	
	obj_assign(n,1,x1,110, 100,20,Black,False ,FontHand(0),0,"Text Color","")
	MF(n,5)=obj_assign(n,12,x2,110, 100,18,14,8,FontHand(0),0,c$,"TC")

	;check box
	MF(n,6)=obj_assign(n,4,x2,133,14,14,x1,130,FontHand(0),0,"Center","CEN")
	
	obj_assign(n,1,x1,150, 100,20,Black,False ,FontHand(0),0,"Font","")
	MF(n,7)=obj_assign(n,7,x2,150, 100,14,True,0,5,0,"","FONT")
	
	;Fld 8 not used

	obj_assign(n,1,x1,190, 100,20,Black,False ,FontHand(0),0,"Text","")
	MF(n,9)=obj_assign(n,6,x2,190, 100,18,Black,white,FontHand(0),False,"","OBTEXT")

	;buttons
	obj_assign(n,3, 10,220,60,20,gray,white,FontHand(0),False,"Cancel","CAN")
	obj_assign(n,3,110,220,60,20,gray,white,FontHand(0),False,"Done","DONE")

	Focus_Find(n)
	MF(n,10)=Form_Image(n)


	;Form 2: Label ********************************************************
	n=2: 

	obj_assign(n,0,scrnW-fw-4,100,fw,250,white,ltgray ,FontHand(0),2,"","")
	obj_assign(n,9,0,0,fw-1,20,Black,Blue,MenuFnt,2," Label Object Properties ","FRM2")
	;sliders slider labels
	
	obj_assign(n,1,x1, 30, 100,20,Black,False ,FontHand(0),0,"X Pos","")
	MF(n,1)=obj_assign(n,7,x2, 30, 100,14,True,0,scrnW-fw-100,0,"","XPOS")
	
	obj_assign(n,1,x1, 50, 100,20,Black,False ,FontHand(0),0,"Y Pos","")
	MF(n,2)=obj_assign(n,7,x2, 50, 100,14,True,0,ScrnH-100,0,"","YPOS")
	
	obj_assign(n,1,x1, 70, 100,20,Black,False ,FontHand(0),0,"Width","")
	MF(n,3)=obj_assign(n,7,x2, 70, 100,14,True,0,ScrnW-100,0,"","W")
	
	obj_assign(n,1,x1, 90, 100,20,Black,False ,FontHand(0),0,"Height","")
	MF(n,4)=obj_assign(n,7,x2, 90, 100,14,True,0,ScrnH-100,0,"","H")
	
					obj_assign(n, 1,x1,110,100,20,Black,False ,FontHand(0),0,"Text Color","")
	MF(n,5)=obj_assign(n,12,x2,110,100,18,14,8,FontHand(0),0,c$,"TC")

	obj_assign(n,1,x1,130, 100,20,Black,False ,FontHand(0),0,"Bck Color","")
	MF(n,6)=obj_assign(n,12,x2,130, 100,18,14,8,FontHand(0),0,c$,"BC")

	obj_assign(n,1,x1,150, 100,20,Black,False ,FontHand(0),0,"Font","")
	MF(n,7)=obj_assign(n,7,x2,150, 100,14,True,0,5,0,"","FONT")
	
	;check box
	MF(n,8)=obj_assign(n,4,x2,173,14,14,x1,170,FontHand(0),0,"Center","CEN")

	obj_assign(n,1,x1,190, 100,20,Black,False ,FontHand(0),0,"Text","")
	MF(n,9)=obj_assign(n,6,x2,190, 100,18,Black,white,FontHand(0),False,"","OBTEXT")

	;buttons
	obj_assign(n,3, 10,220,60,20,gray,white,FontHand(0),False,"Cancel","CAN")
	obj_assign(n,3,110,220,60,20,gray,white,FontHand(0),False,"Done","DONE")

	Focus_Find(n)
	MF(n,10)=Form_Image(n)


	;Form 3: Button ********************************************************
	n=3

	obj_assign(n,0,scrnW-fw-4,100,fw,250,white,ltgray ,FontHand(0),2,"","")
	obj_assign(n,9,0,0,fw-1,20,Black,Blue,MenuFnt,2," Button Object Properties ","FRM3")
	;sliders slider labels
	
	obj_assign(n,1,x1, 30, 100,20,Black,False ,FontHand(0),0,"X Pos","")
	MF(n,1)=obj_assign(n,7,x2, 30, 100,14,True,0,scrnW-fw-100,0,"","XPOS")
	
	obj_assign(n,1,x1, 50, 100,20,Black,False ,FontHand(0),0,"Y Pos","")
	MF(n,2)=obj_assign(n,7,x2, 50, 100,14,True,0,ScrnH-100,0,"","YPOS")
	
	obj_assign(n,1,x1, 70, 100,20,Black,False ,FontHand(0),0,"Width","")
	MF(n,3)=obj_assign(n,7,x2, 70, 100,14,True,0,ScrnW-100,0,"","W")
	
	obj_assign(n,1,x1, 90, 100,20,Black,False ,FontHand(0),0,"Height","")
	MF(n,4)=obj_assign(n,7,x2, 90, 100,14,True,0,ScrnH-100,0,"","H")
	
					obj_assign(n, 1,x1,110,100,20,Black,False ,FontHand(0),0,"Background","")
	MF(n,5)=obj_assign(n,12,x2,110,100,18,14,8,FontHand(0),0,c$,"BC")

	obj_assign(n,1,x1,130, 100,20,Black,False ,FontHand(0),0,"Text Color","")
	MF(n,6)=obj_assign(n,12,x2,130, 100,18,14,8,FontHand(0),0,c$,"TC")

	obj_assign(n,1,x1,150, 100,20,Black,False ,FontHand(0),0,"Font","")
	MF(n,7)=obj_assign(n,7,x2,150, 100,14,True,0,5,0,"","FONT")
	
	;Fld 8 Status(pressed)
	MF(n,8)=0

	obj_assign(n,1,x1,170, 100,20,Black,False ,FontHand(0),0,"Text","")
	MF(n,9)=obj_assign(n,6,x2,170, 100,18,Black,white,FontHand(0),False,"","OBTEXT")

	obj_assign(n,1,x1,190, 100,20,Black,False ,FontHand(0),0,"Return Text","")
	MF(n,11)=obj_assign(n,6,x2,190, 100,18,Black,white,FontHand(0),False,"","RTEXT")

	;buttons
	obj_assign(n,3, 10,220,60,20,gray,white,FontHand(0),False,"Cancel","CAN")
	obj_assign(n,3,110,220,60,20,gray,white,FontHand(0),False,"Done","DONE")

	Focus_Find(n)
	MF(n,10)=Form_Image(n)


	;Form 4: Check box ********************************************************
	n=4

	obj_assign(n,0,scrnW-fw-4,100,fw,250,white,ltgray ,FontHand(0),2,"","")
	obj_assign(n,9,0,0,fw-1,20,Black,Blue,MenuFnt,2," Check box Object Properties ","FRM4")
	;sliders slider labels
	
	obj_assign(n,1,x1, 30, 100,20,Black,False ,FontHand(0),0,"X Pos","")
	MF(n,1)=obj_assign(n,7,x2, 30, 100,14,True,0,scrnW-fw-100,0,"","XPOS")
	
	obj_assign(n,1,x1, 50, 100,20,Black,False ,FontHand(0),0,"Y Pos","")
	MF(n,2)=obj_assign(n,7,x2, 50, 100,14,True,0,ScrnH-100,0,"","YPOS")
	
	obj_assign(n,1,x1, 70, 100,20,Black,False ,FontHand(0),0,"Width","")
	MF(n,3)=obj_assign(n,7,x2, 70, 100,14,True,0,ScrnW-100,0,"","W")
	
	obj_assign(n,1,x1, 90, 100,20,Black,False ,FontHand(0),0,"Height","")
	MF(n,4)=obj_assign(n,7,x2, 90, 100,14,True,0,ScrnH-100,0,"","H")
	
	obj_assign(n,1,x1,110, 100,20,Black,False ,FontHand(0),0,"Text X","")
	MF(n,5)=obj_assign(n,7,x2,110, 100,14,True,0,ScrnW-100,0,"","TX")
	
	obj_assign(n,1,x1,130, 100,20,Black,False ,FontHand(0),0,"Text Y","")
	MF(n,6)=obj_assign(n,7,x2,130, 100,14,True,0,ScrnH-100,0,"","TY")
	
	obj_assign(n,1,x1,150, 100,20,Black,False ,FontHand(0),0,"Font","")
	MF(n,7)=obj_assign(n,7,x2,150, 100,14,True,0,5,0,"","FONT")
	
	;Fld 8 Status(checked)
	MF(n,8)=0

	obj_assign(n,1,x1,170, 100,20,Black,False ,FontHand(0),0,"Text","")
	MF(n,9)=obj_assign(n,6,x2,170, 100,18,Black,white,FontHand(0),False,"","CKTEXT")

	obj_assign(n,1,x1,190, 100,20,Black,False ,FontHand(0),0,"Return Text","")
	MF(n,11)=obj_assign(n,6,x2,190, 100,18,Black,white,FontHand(0),False,"","RTEXT")

	;buttons
	obj_assign(n,3, 10,220,60,20,gray,white,FontHand(0),False,"Cancel","CAN")
	obj_assign(n,3,110,220,60,20,gray,white,FontHand(0),False,"Done","DONE")

	Focus_Find(n)
	MF(n,10)=Form_Image(n)

	;Form 5: Radio button ********************************************************
	n=5

	obj_assign(n,0,scrnW-fw-4,100,fw,250,white,ltgray ,FontHand(0),2,"","")
	obj_assign(n,9,0,0,fw-1,20,Black,Blue,MenuFnt,2," Radio Button Object Properties ","FRM4")
	;sliders slider labels
	
	obj_assign(n,1,x1, 30, 100,20,Black,False ,FontHand(0),0,"X Pos","")
	MF(n,1)=obj_assign(n,7,x2, 30, 100,14,True,0,scrnW-fw-100,0,"","XPOS")
	
	obj_assign(n,1,x1, 50, 100,20,Black,False ,FontHand(0),0,"Y Pos","")
	MF(n,2)=obj_assign(n,7,x2, 50, 100,14,True,0,ScrnH-100,0,"","YPOS")
	
	obj_assign(n,1,x1, 70, 100,20,Black,False ,FontHand(0),0,"Radius","")
	MF(n,3)=obj_assign(n,7,x2, 70, 100,14,True,0,ScrnW-100,0,"","W")
	
	obj_assign(n,1,x1, 90, 100,20,Black,False ,FontHand(0),0,"Height","")
	MF(n,4)=obj_assign(n,7,x2, 90, 100,14,True,0,ScrnH-100,0,"","H")
	
	obj_assign(n,1,x1,110, 100,20,Black,False ,FontHand(0),0,"Text X","")
	MF(n,5)=obj_assign(n,7,x2,110, 100,14,True,0,ScrnW-100,0,"","TX")
	
	obj_assign(n,1,x1,130, 100,20,Black,False ,FontHand(0),0,"Button Group","")
	MF(n,6)=obj_assign(n,7,x2,130, 100,14,True,0,ScrnH-100,0,"","BG")
	
	obj_assign(n,1,x1,150, 100,20,Black,False ,FontHand(0),0,"Font","")
	MF(n,7)=obj_assign(n,7,x2,150, 100,14,True,0,5,0,"","FONT")
	
	;Fld 8 Status(checked)
	MF(n,8)=0

	obj_assign(n,1,x1,170, 100,20,Black,False ,FontHand(0),0,"Radio Text","")
	MF(n,9)=obj_assign(n,6,x2,170, 100,18,Black,white,FontHand(0),False,"","TEXT")

	obj_assign(n,1,x1,190, 100,20,Black,False ,FontHand(0),0,"Return Text","")
	MF(n,11)=obj_assign(n,6,x2,190, 100,18,Black,white,FontHand(0),False,"","RTEXT")

	;buttons
	obj_assign(n,3, 10,220,60,20,gray,white,FontHand(0),False,"Cancel","CAN")
	obj_assign(n,3,110,220,60,20,gray,white,FontHand(0),False,"Done","DONE")

	Focus_Find(n)
	MF(n,10)=Form_Image(n)


	;Form 6: Edit Box ********************************************************
	n=6

	obj_assign(n,0,scrnW-fw-4,100,fw,250,white,ltgray ,FontHand(0),2,"","")
	obj_assign(n,9,0,0,fw-1,20,Black,Blue,MenuFnt,2," Edit Box Object Properties ","FRM6")
	
	obj_assign(n,1,x1, 30, 100,20,Black,False ,FontHand(0),0,"X Pos","")
	MF(n,1)=obj_assign(n,7,x2, 30, 100,14,True,0,scrnW-fw-100,0,"","XPOS")
	
	obj_assign(n,1,x1, 50, 100,20,Black,False ,FontHand(0),0,"Y Pos","")
	MF(n,2)=obj_assign(n,7,x2, 50, 100,14,True,0,ScrnH-100,0,"","YPOS")
	
	obj_assign(n,1,x1, 70, 100,20,Black,False ,FontHand(0),0,"Width","")
	MF(n,3)=obj_assign(n,7,x2, 70, 100,14,True,0,ScrnW-100,0,"","W")
	
	obj_assign(n,1,x1, 90, 100,20,Black,False ,FontHand(0),0,"Height","")
	MF(n,4)=obj_assign(n,7,x2, 90, 100,14,True,0,ScrnH-100,0,"","H")
	
					obj_assign(n, 1,x1,110,100,20,Black,False ,FontHand(0),0,"Text Color","")
	MF(n,5)=obj_assign(n,12,x2,110,100,18,14,8,FontHand(0),0,c$,"TC")

	obj_assign(n,1,x1,130, 100,20,Black,False ,FontHand(0),0,"Background","")
	MF(n,6)=obj_assign(n,12,x2,130, 100,18,14,8,FontHand(0),0,c$,"BC")

	obj_assign(n,1,x1,150, 100,20,Black,False ,FontHand(0),0,"Font","")
	MF(n,7)=obj_assign(n,7,x2,150, 100,14,True,0,5,0,"","FONT")
	
	;Fld 8 Status(pressed)
	MF(n,8)=0

	obj_assign(n,1,x1,170, 100,20,Black,False ,FontHand(0),0,"Text","")
	MF(n,9)=obj_assign(n,6,x2,170, 100,18,Black,white,FontHand(0),False,"","EDIT TEXT")

	obj_assign(n,1,x1,190, 100,20,Black,False ,FontHand(0),0,"Return Text","")
	MF(n,11)=obj_assign(n,6,x2,190, 100,18,Black,white,FontHand(0),False,"","RTEXT")

	;buttons
	obj_assign(n,3, 10,220,60,20,gray,white,FontHand(0),False,"Cancel","CAN")
	obj_assign(n,3,110,220,60,20,gray,white,FontHand(0),False,"Done","DONE")

	Focus_Find(n)
	MF(n,10)=Form_Image(n)


	;Form 7: H Slider  ********************************************************
	n=7

	obj_assign(n,0,scrnW-fw-4,100,fw,250,white,ltgray ,FontHand(0),2,"","")
	obj_assign(n,9,0,0,fw-1,20,Black,Blue,MenuFnt,2," Horizontial Slider Object Properties ","FRM7")
	
	obj_assign(n,1,x1, 30, 100,20,Black,False ,FontHand(0),0,"X Pos","")
	MF(n,1)=obj_assign(n,7,x2, 30, 100,14,True,0,scrnW-fw-100,0,"","XPOS")
	
	obj_assign(n,1,x1, 50, 100,20,Black,False ,FontHand(0),0,"Y Pos","")
	MF(n,2)=obj_assign(n,7,x2, 50, 100,14,True,0,ScrnH-100,0,"","YPOS")
	
	obj_assign(n,1,x1, 70, 100,20,Black,False ,FontHand(0),0,"Width","")
	MF(n,3)=obj_assign(n,7,x2, 70, 100,14,True,0,ScrnW-100,0,"","W")
	
	obj_assign(n,1,x1, 90, 100,20,Black,False ,FontHand(0),0,"Height","")
	MF(n,4)=obj_assign(n,7,x2, 90, 100,14,True,0,ScrnH-100,0,"","H")
	
	obj_assign(n,1,x1,110, 100,20,Black,False ,FontHand(0),0,"Option","")
	MF(n,5)=obj_assign(n,7,x2,110, 100,14,True,-2,1,1,"","OPT")
	
	obj_assign(n,1,x1,130, 100,20,Black,False ,FontHand(0),0,"Min Value ","")
	MF(n,6)=obj_assign(n,7,x2,130, 100,14,True,-1000,1,0,"","MINV")
	
	obj_assign(n,1,x1,150, 100,20,Black,False ,FontHand(0),0,"Max Value","")
	MF(n,7)=obj_assign(n,7,x2,150, 100,14,True,0,1000,0,"","MAXV")
	
	;Fld 8 Value
	obj_assign(n,1,x1,170, 100,20,Black,False ,FontHand(0),0,"Init Value","")
	MF(n,8)=obj_assign(n,7,x2,170, 100,14,True,0,1000,0,"","MAXV")
	
	obj_assign(n,1,x1,190, 100,20,Black,False ,FontHand(0),0,"Return Text","")
	MF(n,11)=obj_assign(n,6,x2,190, 100,18,Black,white,FontHand(0),False,"","RTEXT")

	;buttons
	obj_assign(n,3, 10,220,60,20,gray,white,FontHand(0),False,"Cancel","CAN")
	obj_assign(n,3,110,220,60,20,gray,white,FontHand(0),False,"Done","DONE")

	Focus_Find(n)
	MF(n,10)=Form_Image(n)

	;Form 8: V Slider  ********************************************************
	n=8

	obj_assign(n,0,scrnW-fw-4,100,fw,250,white,ltgray ,FontHand(0),2,"","")
	obj_assign(n,9,0,0,fw-1,20,Black,Blue,MenuFnt,2," Vertical Slider Object Properties ","FRM8")
	
	obj_assign(n,1,x1, 30, 100,20,Black,False ,FontHand(0),0,"X Pos","")
	MF(n,1)=obj_assign(n,7,x2, 30, 100,14,True,0,scrnW-fw-100,0,"","XPOS")
	
	obj_assign(n,1,x1, 50, 100,20,Black,False ,FontHand(0),0,"Y Pos","")
	MF(n,2)=obj_assign(n,7,x2, 50, 100,14,True,0,ScrnH-100,0,"","YPOS")
	
	obj_assign(n,1,x1, 70, 100,20,Black,False ,FontHand(0),0,"Width","")
	MF(n,3)=obj_assign(n,7,x2, 70, 100,14,True,0,ScrnW-100,0,"","W")
	
	obj_assign(n,1,x1, 90, 100,20,Black,False ,FontHand(0),0,"Height","")
	MF(n,4)=obj_assign(n,7,x2, 90, 100,14,True,0,ScrnH-100,0,"","H")
	
	obj_assign(n,1,x1,110, 100,20,Black,False ,FontHand(0),0,"Option","")
	MF(n,5)=obj_assign(n,7,x2,110, 100,14,True,-2,1,1,"","OPT")
	
	obj_assign(n,1,x1,130, 100,20,Black,False ,FontHand(0),0,"Min Value ","")
	MF(n,6)=obj_assign(n,7,x2,130, 100,14,True,-1000,1,0,"","MINV")
	
	obj_assign(n,1,x1,150, 100,20,Black,False ,FontHand(0),0,"Max Value","")
	MF(n,7)=obj_assign(n,7,x2,150, 100,14,True,0,1000,0,"","MAXV")
	
	;Fld 8 Value
	obj_assign(n,1,x1,170, 100,20,Black,False ,FontHand(0),0,"Init Value","")
	MF(n,8)=obj_assign(n,7,x2,170, 100,14,True,0,1000,0,"","MAXV")
	
	obj_assign(n,1,x1,190, 100,20,Black,False ,FontHand(0),0,"Return Text","")
	MF(n,11)=obj_assign(n,6,x2,190, 100,18,Black,white,FontHand(0),False,"","RTEXT")

	;buttons
	obj_assign(n,3, 10,220,60,20,gray,white,FontHand(0),False,"Cancel","CAN")
	obj_assign(n,3,110,220,60,20,gray,white,FontHand(0),False,"Done","DONE")

	Focus_Find(n)
	MF(n,10)=Form_Image(n)


	;Form 9: Title bar  ********************************************************
	n=9

	obj_assign(n,0,scrnW-fw-4,100,fw,250,white,ltgray ,FontHand(0),2,"","")
	obj_assign(n,9,0,0,fw-1,20,Black,Blue,MenuFnt,2," Title Bar Object Properties ","FRM8")
	
	
	obj_assign(n,1,x1, 70, 100,20,Black,False ,FontHand(0),0,"Width","")
	MF(n,3)=obj_assign(n,7,x2, 70, 100,14,True,0,ScrnW-100,0,"","W")
	
	obj_assign(n,1,x1, 90, 100,20,Black,False ,FontHand(0),0,"Height","")
	MF(n,4)=obj_assign(n,7,x2, 90, 100,14,True,0,ScrnH-100,0,"","H")
	
	
	;Fld 8 Value
	;check box
	MF(n,8)=obj_assign(n,4,x2,133,14,14,x1,130,FontHand(0),0,"Title","")
	
	obj_assign(n,1,x1,190, 100,20,Black,False ,FontHand(0),0,"Text","")
	MF(n,9)=obj_assign(n,6,x2,190, 100,18,Black,white,FontHand(0),False,"","")

	;buttons
	obj_assign(n,3, 10,220,60,20,gray,white,FontHand(0),False,"Cancel","CAN")
	obj_assign(n,3,110,220,60,20,gray,white,FontHand(0),False,"Done","DONE")

	Focus_Find(n)
	MF(n,10)=Form_Image(n)


End Function


Function XPOS(i,n,w,ww)

	bw=(ww-n*w)/(n+1)
	Return bw+(bw+w)*(i-1)
	
End Function



Function LoadMouse()
	
	Read w,h, hx,hy
	If w>32 Then
	  m=CreateImage(w,h)
	Else
	  ;image must be wider than 32 pixels to work on my laptop
	  m=CreateImage(33,h)	
	EndIf
	SBuffer=ImageBuffer(m)
	SetBuffer SBuffer
	
	LockBuffer 
	  For y=0 To h-1
		For x=0 To w-1
		  Read rgb
		  WritePixelFast(x,y,rgb)
		Next
	  Next
	UnlockBuffer
	HandleImage m,hx,hy
	SetBuffer BackBuffer()
	
	Return m
	
End Function


Function saveBMP(f$)
	zhand=CreateImage (scrnW,ScrnH)
	GrabImage zhand,0,0
	SaveImage zhand,f$
	FreeImage zHand
End Function
	

;Data **************************************************************

.pointerdata
Data 11, 19, 0, 0
Data 526344 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 526344 ,526344 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 526344 ,16317688 ,526344 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 526344 ,16317688 ,16317688 ,526344 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 526344 ,16317688 ,16317688 ,16317688 ,526344 ,0 ,0 ,0 ,0 ,0 ,0
Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,0 ,0 ,0 ,0 ,0
Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,0 ,0 ,0 ,0
Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,0 ,0 ,0
Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,0 ,0
Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,0
Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,526344 ,526344 ,526344 ,526344
Data 526344 ,16317688 ,16317688 ,526344 ,16317688 ,16317688 ,526344 ,0 ,0 ,0 ,0
Data 526344 ,16317688 ,526344 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0 ,0 ,0
Data 526344 ,526344 ,0 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0 ,0 ,0
Data 526344 ,0 ,0 ,0 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,526344 ,526344 ,0 ,0

.Movepointerdata
Data 25, 25, 12, 12
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,16317688 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,16317688 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16252928 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0
Data 0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0
;this line is broken in two
Data 0 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16252928 ,0 ,16252928 
Data 0 ,16252928 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,0
Data 0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0
Data 0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16252928 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,16317688 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,16317688 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0
Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0