
Global  nMenus=5,nSubMenus=8
Global nWinObj, WinVS, WinHS
Dim    WinObj(10,10),EditText$(5)
Dim    nSubm(nMenus,2), Submenu$(nMenus,nSubMenus),menuFlag(nMenus,nSubMenus)
Dim    ret$(nMenus,nSubMenus), keyVal(nMenus,nSubMenus)

.menudata
Data 1,"File","",0
Data 1,"  New       ",		"NEW",0
Data 1,"  Save   F10",		"SAVE",68
Data 1,"  Load   F7 ",		"LOAD",65
Data 1,"  Make .bb  ",		"MAKE",0
Data 1,"  Screenshot F9",	"SSHOT",67
Data 1,"  Quit   esc",		"QUIT",1
Data 2,"Edit",				"",0
Data 2,"  Delete  Del",		"DEL",211
Data 2,"  Duplicate ",		"DUP",0
Data 2,"  Next    F2",		"NEXT",60
Data 3,"Aline","",0
Data 3,"  Left",		"ALL",0
Data 3,"  Right",		"ALR",0
Data 3,"  Top  ",		"ALT",0
Data 3,"  Bottom",		"ALB",0
Data 3,"  Center X",		"ALC",0
Data 3,"  Center Y",		"ALH",0
Data 4,"Space  ",		"",0
Data 4,"  Vertical",		"SPV",0
Data 4,"  Horizontial",	"SPH",0
Data 5,"Add Object","",0
Data 5," Title Bar ","TBAR",0
Data 5," Text","TEXT",0
Data 5," Label","LAB",0
Data 5," Button","BUT",0
Data 5," Checkbox","CKBOX",0
Data 5," Radio","RAD",0
Data 5," Edit Box","EDIT",0
Data 5,"END MENU DATA",		"",0




Function MENU_Activate (X, Y)
	;checks whether mouse is down over menu bar
  If Y > MENUHeight Then
    Return  False
  ElseIf X > WinX+MENUWidth*nMenus Then
    Return  False
  Else
		Return  True
  End If
End Function


Function Menu_Load()
	;function to load menu from data statements
  For M = 1 To nMenus: nSubm(M,1) = -1: Next 
  Repeat 
    Read M,mtxt$, r$, keyN
		nSubm(M,1) = nSubm(M,1) + 1
  	If nSubm(M,1) >nSubMenus Then
		  Stop
		  nSubm(M,1) = nSubm(M,1) - 1
		ElseIf Upper$(mtxt$)="END MENU DATA"
		  nSubm(M,1) = nSubm(M,1) - 1
			nMenus=M
		  Exit
  	Else
      SubMenu$(M, nSubm(M,1)) = mtxt$
		  ret$(M, nSubm(M,1)) = r$
      keyVal(M, nSubm(M,1)) = keyN
  	End If
  Forever
End Function


Function MENU_Assign (M, txt$, r$, keyN)
	;Funtion to directly put menu data into the menu arrays
  nSubm(M,1) = nSubm(M,1) + 1
  If nSubm(M,1) >nSubMenus Then
  Else
    SubMenu$(M, nSubm(M,1)) = txt$
		ret$(M, nSubm(M,1)) = r$
    keyVal(M, nSubm(M,1)) = keyN
  End If
End Function


Function MENU_Get$ (mx,img)
	;Function to control screen while user is selecting a menu item
	;mx=mouse X, img=screenimage
	
  tmenu = MiniMax( Int((mx-winX)/MenuWidth)+1, 1,nMenus)
  Repeat: Until Not MouseDown(1)	;wait for mouse release
  
  Repeat
		mx=MouseX()
		my=MouseY()
    Tx = MiniMax(Int((mx-WinX) / MenuWidth) + 1,1,nMenus)
    Ty = MiniMax((my)/MenuHeight,1,nSubm(tx,1))
    If Tx <> tmenu Or Ty <> cMenu 
      tmenu = Tx
      cMenu = Ty
		End If
    DrawBlock Img,0,0
		Menu_Draw_Sub(tmenu,cMenu)
    DrawImage mouseImage,mx,my
    Flip
  Until MouseDown(1)

	While MouseDown(1): Wend

  w=winX+MenuWidth*(nMenus-1)+nSubm(tMenu,2)
  If mx > w Then
    Return  ""
  Else If my > (nSubm(Tx,1)+1)*MenuHeight Then
    Return ""
  Else 
    Return ret$(Tx,Ty)
  End If
End Function


Function MENU_DRAW()
  ;Draws to active buffer
  ;Draw Menubar
  Origin winX,0
  Color 0,0,255
  Rect 0,0,MENUWidth*nMenus,MENUHeight
  Color 255,255,255
  Line 0,MENUHeight-1,MENUWidth * nMenus,MENUHeight-1
  If MenuFnt>0  Then SetFont MenuFnt
  For M = 1 To nMenus
     Text MenuWidth * (M - 1), 0, SubMenu$(M, 0)
  Next 
  Origin 0,0
End Function


Function Menu_Draw_Sub(tMenu,cMenu)
	
	SetFont fonthand(0)
	If nSubm(tMenu,2)=0
	  For n = 1 To nSubm(tMenu,1) 
			If StringWidth(SubMenu$(tMenu,n))>w Then w=StringWidth(SubMenu$(tMenu,n))+10
		Next
  	nSubm(tMenu,2)=w
	Else
	  w=nSubm(tMenu,2)
	EndIf
  h=nSubm(tmenu,1) * MENUHeight+4

  Origin WinX+MENUWidth * (tmenu - 1),MENUHeight
  Color 0,0,255
  Rect  0,0,w,h					;inside
  Color 255,0,0
  Rect  0, 0,w,  h,0		;shadow border
  Rect  0, 0,w-1,h-1,0
  Line  0, h-2,w-1,h-2
  Color 255,255,255
  Line  0,0,w-1,0				;light border
  Line  0,0,0,h-1

	Color 255,255,255
  For n = 1 To nSubm(tMenu,1) 
		t$=SubMenu$(tMenu,n)
		If menuFlag(tMenu,n) And 1 Then t$="*"+Right$(t$,Len(t$)-1)
		y=(n-1) * MENUHeight+2
		If n=cMenu Then 
		  Rect 	2, y+1,w-5,MENUHeight
		  Color 0,0,255
	    Text 4,y,t$
			Color 255,255,255
		Else
	    Text 4,y,t$
		EndIf
  Next  
	Origin 0,0

End Function


Function MENU_KEY$()
  ; Check For menu hot key
	; KeyVal() contains scan codes! 
  For M = 1 To nMenus
    For n = 1 To nSubm(M,1)
      If KeyDown(keyVal(M, n)) Then 
				While KeyDown(keyVal(M, n)): Wend  ;wait for key release
				Return  ret$(M, n)
			EndIf
    Next 
  Next 
	Return ""
End Function


Function MENU_Toggle(MenuText$, r$)
  ;changes the menu text for the menu 
  ;entry with a Return value of r$
	;MenuText$= new menutext$
	;r$ = return text value of menu item, used for matching
	
  For M = 1 To nMenus
    For n = 1 To nSubmenus
      If r$ = ret$(M, n) Then
				;found a match, change and return
				;menu_image needs to be called to update image
        SubMenu$(M, n) =  MenuText$
        Return
      End If 
    Next 
  Next
End Function

Function	Menu_FlagSet(r$,flag,bit2set)
	If LongMask=0 Then Stop	;Vodo precaution
	
  For M = 1 To nMenus
    For n = 1 To nSubmenus
      If r$ = ret$(M, n) Then
				;found a match, change and return
				;clear bit first to be safe
				msk = LongMask Xor bit2set
        MenuFlag(M, n)=MenuFlag(M, n) And msk
				;now set it
				If flag=0 Then Return
        MenuFlag(M, n)=MenuFlag(M, n) Or bit2set
        Return
      End If 
    Next 
  Next

End Function